c this file is written by Thi Nhung Dao
c uncomment the following line if one use EMT scheme in te stop/stop sector
#define DENNERSCHEME
c uncomment the above line if using the EMT scheme
#ifdef DENNERSCHEME  
#define DBLEK DBLE
#else
#define DBLEK 
#endif

c stop selfenergies
c Subroutine SelfStop(P2,i1,i2,self,iEW,iuv) using DBLEK, looptools
c Subroutine SelfStopFull(P2,i1,i2,self,iEW,iuv) using DBLEN(x)=x, looptools
c Subroutine DSelfStop(P2,i1,i2,Dself,iew,iuv) using DBLEK, looptools
c Subroutine SelfStopReti(P2,i1,i2,self,iEW,iuv) using DBLE,
c
c
c top selfenergies
c Subroutine Selftop(P2,i1,i2,selfT,iew,iUV), using DBLEK, looptools
c Subroutine Selftopfin(P2,i1,i2,selfT,iew), using DBLEK
c
c bottom selfenergies
c Subroutine Selfbottom(P2,i1,i2,selfB,iew,iuv), using DBLEK, looptools
c Subroutine Selfbottomfin(P2,i1,i2,selfB,iew), using DBLEK
c
c sbottom selfenergies
c Subroutine SelfSbottom(P2,i1,i2,self,iew,iuv), using DBLEK, looptools
c Subroutine SelfSbottomN(P2,i1,i2,self,iew,iuv), using DBLEN, looptools
c Subroutine DSelfSbottom(P2,i1,i2,Dself,iew,iuv), suing DBLEK, looptools
c Subroutine SelfSbottomReti(P2,i1,i2,self,iew,iuv), using DBLE
c
c function SelfHZ(P2,i)  keep imaginary of B0,looptools
c
c function SelfHH(P2,i,j) keep imaginary of B0,looptools
c
c function SelfCH(P2,i,j,iself) keep imaginary of B0



c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	Subroutine SelfStop(P2,i1,i2,self,iEW,iuv)
        implicit none
#include "looptools.h"  
	integer i,igen,gt1,gt2,gt3,gt4,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3,I3G5,i1,i2,IndexDelta,
     &          iEW,iuv

        double precision Q,P2,MGL,MGL2,divergence
        
      double precision absM3, phiM3
      common /gluino/ absM3,phiM3

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)

      double precision ZH5(5,5),ZH(6,6)    
      double complex UM(2,2),UP(2,2),NN(5,5),ZEN(6,6),ZDN(6,6),ZUN(6,6)
    
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3

      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv

      common /rot/ ZH5,ZH,UM,UP,NN,ZEN,ZDN,ZUN

      double complex IC,x,self
#include "HdecayTCLs.inc"
      if (iuv.eq.1)then
        self=0D0
        return
      endif

        IC=(0,1D0)
        MGL=absM3;MGL2=MGL**2
       if (i1.eq.i2) then
        IndexDelta=1
       else 
        IndexDelta=0
       endif
       self=0D0
       if (iew.eq.1)then
       self=self+(-2*(-18*A0(MW2)*CSuSuWW(i2,i1)-9*A0(MZ2)*
     &  CSuSuZZ(i2,i1)+2*e**2*IndexDelta*(2*p2*
     &  DBLEK(B0i(bb1,p2,0D0,MSu2(i1)))+DBLEK(B0i(bb0,p2,0D0,MSu2(i1)))*
     &  (3*p2+MSu2(i1)))))/9.

c this change does not give uv finite result 
c       self=self+(-2*(-18*A0(MW2)*CSuSuWW(i2,i1)-9*A0(MZ2)*
c     &  CSuSuZZ(i2,i1)+2*e**2*IndexDelta*(2*p2*
c     &  DBLEK(B0i(bb1,p2,0D0,P2))+DBLEK(B0i(bb0,p2,0D0,P2))*
c     &  (3*p2+P2))))/9.

    	do I2G3 = 1,2
       self=self+IC*A0(MassHpm2(I2G3))*CHmHpSupSum(i2,I2G3,i1,I2G3)
    	enddo
    	do I3G3 = 1,3
       self=self-(A0(MSv2(I3G3))*CSu2Sv2(i2,i1,I3G3))
    	enddo
    	do I2G3 = 1,2
    	do I3G3 = 1,3
       self=self-2*(A0(MCha2(I2G3))*(cdmchapsuL(I3G3,I2G3,i2)*
     &  DCONJG(cdmchapsuL(I3G3,I2G3,i1))+cdmchapsuR(I3G3,I2G3,i2)*
     &  DCONJG(cdmchapsuR(I3G3,I2G3,i1)))+cdmchapsuL(I3G3,I2G3,i2)*(-
     &  (p2*DBLEK(B0i(bb1,p2,MCha2(I2G3),MFd2(I3G3)))*
     &  DCONJG(cdmchapsuL(I3G3,I2G3,i1)))+DBLEK(B0i(bb0,p2,MCha2(I2G3)
     &  ,MFd2(I3G3)))*(DCONJG(cdmchapsuR(I3G3,I2G3,i1))*MassFd(I3G3)*
     &  MCha(I2G3)+DCONJG(cdmchapsuL(I3G3,I2G3,i1))*(-p2+MFd2(I3G3))))+
     &  cdmchapsuR(I3G3,I2G3,i2)*(-(p2*DBLEK(B0i(bb1,p2,MCha2(I2G3)
     &  ,MFd2(I3G3)))*DCONJG(cdmchapsuR(I3G3,I2G3,i1)))+
     &  DBLEK(B0i(bb0,p2,MCha2(I2G3),MFd2(I3G3)))*
     &  (DCONJG(cdmchapsuL(I3G3,I2G3,i1))*MassFd(I3G3)*MCha(I2G3)+
     &  DCONJG(cdmchapsuR(I3G3,I2G3,i1))*(-p2+MFd2(I3G3)))))
    	enddo
    	enddo
    	do I3G3 = 1,3
    	do I5G3 = 1,5
       self=self-2*(A0(MNeu2(I5G3))*(cchiupsumL(I5G3,I3G3,i1)*
     &  DCONJG(cchiupsumL(I5G3,I3G3,i2))+cchiupsumR(I5G3,I3G3,i1)*
     &  DCONJG(cchiupsumR(I5G3,I3G3,i2)))+cchiupsumR(I5G3,I3G3,i1)*(-
     &  (p2*DBLEK(B0i(bb1,p2,MNeu2(I5G3),MFu2(I3G3)))*
     &  DCONJG(cchiupsumR(I5G3,I3G3,i2)))+DBLEK(B0i(bb0,p2,MFu2(I3G3)
     &  ,MNeu2(I5G3)))*(DCONJG(cchiupsumR(I5G3,I3G3,i2))*(-p2+
     &  MFu2(I3G3))+DCONJG(cchiupsumL(I5G3,I3G3,i2))*MassFu(I3G3)*
     &  MNeu(I5G3)))+cchiupsumL(I5G3,I3G3,i1)*(-(p2*
     &  DBLEK(B0i(bb1,p2,MNeu2(I5G3),MFu2(I3G3)))*
     &  DCONJG(cchiupsumL(I5G3,I3G3,i2)))+DBLEK(B0i(bb0,p2,MFu2(I3G3)
     &  ,MNeu2(I5G3)))*(DCONJG(cchiupsumL(I5G3,I3G3,i2))*(-p2+
     &  MFu2(I3G3))+DCONJG(cchiupsumR(I5G3,I3G3,i2))*MassFu(I3G3)*MNeu(I5G3))))
    	enddo
    	enddo
    	do I6G3 = 1,6
       self=self+((IC*A0(Masshh2(I6G3))*ChhSupSum(i2,I6G3,i1,I6G3))
     &  /2.-A0(MSd2(I6G3))*(3*CSu2Sd2p1(i2,i1,I6G3,I6G3)+
     &  CSu2Sd2p2(i2,i1,I6G3,I6G3))-A0(MSe2(I6G3))*
     &  CSu2Se2(i2,i1,I6G3,I6G3)-A0(MSu2(I6G3))*
     &  CSu4p1(i2,I6G3,i1,I6G3)-3*A0(MSu2(I6G3))*
     &  CSu4p2(i2,I6G3,i1,I6G3)-A0(MZ2)*CsupsumZ(i2,I6G3)*
     &  CsupsumZ(I6G3,i1)-3*p2*CsupsumZ(i2,I6G3)*CsupsumZ(I6G3,i1)*
     &  DBLEK(B0i(bb0,p2,MZ2,MSu2(I6G3)))-2*p2*CsupsumZ(i2,I6G3)*
     &  CsupsumZ(I6G3,i1)*DBLEK(B0i(bb1,p2,MZ2,MSu2(I6G3)))-A0(MW2)*
     &  CsdsuW(I6G3,i1)*DCONJG(CsdsuW(I6G3,i2))-3*p2*CsdsuW(I6G3,i1)*
     &  DBLEK(B0i(bb0,p2,MW2,MSd2(I6G3)))*DCONJG(CsdsuW(I6G3,i2))-2*
     &  p2*CsdsuW(I6G3,i1)*DBLEK(B0i(bb1,p2,MW2,MSd2(I6G3)))*
     &  DCONJG(CsdsuW(I6G3,i2))-CsdsuW(I6G3,i1)*
     &  DBLEK(B0i(bb0,p2,MW2,MSd2(I6G3)))*DCONJG(CsdsuW(I6G3,i2))*
     &  MSd2(I6G3)-CsupsumZ(i2,I6G3)*CsupsumZ(I6G3,i1)*
     &  DBLEK(B0i(bb0,p2,MZ2,MSu2(I6G3)))*MSu2(I6G3))
    	enddo
    	do I2G3 = 1,2
    	do I6G3 = 1,6
       self=self-(CHmSupSdp(i2,I6G3,I2G3)*CHpSumSdm(I6G3,i1,I2G3)*
     &  DBLEK(B0i(bb0,p2,MassHpm2(I2G3),MSd2(I6G3))))
    	enddo
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       self=self-(ChSupSum(i2,I6G4,I6G3)*ChSupSum(I6G4,i1,I6G3)*
     &  DBLEK(B0i(bb0,p2,Masshh2(I6G3),MSu2(I6G4))))
    	enddo
    	enddo
        elseif(iew.eq.2)then
       self=self+(-4*g3**2*IndexDelta*(2*p2*
     &  DBLEK(B0i(bb1,p2,0D0,MSu2(i1)))+DBLEK(B0i(bb0,p2,0D0,MSu2(i1)))*
     &  (3*p2+MSu2(i1))))/3.

c       self=self+(-4*g3**2*IndexDelta*(2*p2*
c     &  DBLEK(B0i(bb1,p2,0D0,P2))+DBLEK(B0i(bb0,p2,0D0,P2))*
c     &  (3*p2+P2)))/3.
    	do I3G3 = 1,3
       self=self+(-8*g3**2*(A0(MGL2)*(CF15usuL(I3G3,i1)*
     &  DCONJG(CF15usuL(I3G3,i2))+CF15usuR(I3G3,i1)*
     &  DCONJG(CF15usuR(I3G3,i2)))+CF15usuL(I3G3,i1)*(p2*
     &  DBLEK(B0i(bb1,p2,MFu2(I3G3),MGL2))*DCONJG(CF15usuL(I3G3,i2))+
     &  DBLEK(B0i(bb0,p2,MGL2,MFu2(I3G3)))*(-(DCONJG(CF15usuR(I3G3,i2)
     &  )*MassFu(I3G3)*MGL)+DCONJG(CF15usuL(I3G3,i2))*
     &  MFu2(I3G3)))+CF15usuR(I3G3,i1)*(p2*DBLEK(B0i(bb1,p2,MFu2(I3G3)
     &  ,MGL2))*DCONJG(CF15usuR(I3G3,i2))+
     &  DBLEK(B0i(bb0,p2,MGL2,MFu2(I3G3)))*(-(DCONJG(CF15usuL(I3G3,i2)
     &  )*MassFu(I3G3)*MGL)+DCONJG(CF15usuR(I3G3,i2))*
     &  MFu2(I3G3)))))/3.
    	enddo

    	do I6G3 = 1,6
       self=self-(g3**2*(A0(MSd2(I6G3))*(3*CSu2Sd2p1QCD(i2,i1,I6G3,I6G3)
     &  +CSu2Sd2p2QCD(i2,i1,I6G3,I6G3))+A0(MSu2(I6G3))*
     &  (CSu4p1QCD(i2,I6G3,i1,I6G3)+3*CSu4p2QCD(i2,I6G3,i1,I6G3))))
    	enddo

        endif

        self=self*fac
        end Subroutine SelfStop
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Subroutine SelfStopFull(P2,i1,i2,self,iEW,iuv)
      implicit none
#include "looptools.h"  
      integer i,igen,gt1,gt2,gt3,gt4,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3,I3G5,i1,i2,IndexDelta,
     &          iEW,iuv

      double precision Q,P2,MGL,MGL2,divergence
        
      double precision absM3, phiM3
      common /gluino/ absM3,phiM3

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)

      double precision ZH5(5,5),ZH(6,6)    
      double complex UM(2,2),UP(2,2),NN(5,5),ZEN(6,6),ZDN(6,6),ZUN(6,6)
    
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3

      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv

      common /rot/ ZH5,ZH,UM,UP,NN,ZEN,ZDN,ZUN

      double complex IC,x,self,DBLEN
#include "HdecayTCLs.inc"
        DBLEN(x)=x
        IC=(0,1D0)
        MGL=absM3;MGL2=MGL**2
       if (i1.eq.i2) then
        IndexDelta=1
       else 
        IndexDelta=0
       endif
       self=0D0
       if (iew.eq.1)then
       self=self+(-2*(-18*A0(MW2)*CSuSuWW(i2,i1)-9*A0(MZ2)*
     &  CSuSuZZ(i2,i1)+2*e**2*IndexDelta*(2*p2*
     &  DBLEN(B0i(bb1,p2,0D0,MSu2(i1)))+DBLEN(B0i(bb0,p2,0D0,MSu2(i1)))*
     &  (3*p2+MSu2(i1)))))/9.


c this change does not give uv finite result 
c       self=self+(-2*(-18*A0(MW2)*CSuSuWW(i2,i1)-9*A0(MZ2)*
c     &  CSuSuZZ(i2,i1)+2*e**2*IndexDelta*(2*p2*
c     &  DBLEN(B0i(bb1,p2,0D0,P2))+DBLEN(B0i(bb0,p2,0D0,P2))*
c     &  (3*p2+P2))))/9.

    	do I2G3 = 1,2
       self=self+IC*A0(MassHpm2(I2G3))*CHmHpSupSum(i2,I2G3,i1,I2G3)
    	enddo
    	do I3G3 = 1,3
       self=self-(A0(MSv2(I3G3))*CSu2Sv2(i2,i1,I3G3))
    	enddo

    	do I2G3 = 1,2
    	do I3G3 = 1,3
       self=self-2*(A0(MCha2(I2G3))*(cdmchapsuL(I3G3,I2G3,i2)*
     &  DCONJG(cdmchapsuL(I3G3,I2G3,i1))+cdmchapsuR(I3G3,I2G3,i2)*
     &  DCONJG(cdmchapsuR(I3G3,I2G3,i1)))+cdmchapsuL(I3G3,I2G3,i2)*(-
     &  (p2*DBLEN(B0i(bb1,p2,MCha2(I2G3),MFd2(I3G3)))*
     &  DCONJG(cdmchapsuL(I3G3,I2G3,i1)))+DBLEN(B0i(bb0,p2,MCha2(I2G3)
     &  ,MFd2(I3G3)))*(DCONJG(cdmchapsuR(I3G3,I2G3,i1))*MassFd(I3G3)*
     &  MCha(I2G3)+DCONJG(cdmchapsuL(I3G3,I2G3,i1))*(-p2+MFd2(I3G3))))+
     &  cdmchapsuR(I3G3,I2G3,i2)*(-(p2*DBLEN(B0i(bb1,p2,MCha2(I2G3)
     &  ,MFd2(I3G3)))*DCONJG(cdmchapsuR(I3G3,I2G3,i1)))+
     &  DBLEN(B0i(bb0,p2,MCha2(I2G3),MFd2(I3G3)))*
     &  (DCONJG(cdmchapsuL(I3G3,I2G3,i1))*MassFd(I3G3)*MCha(I2G3)+
     &  DCONJG(cdmchapsuR(I3G3,I2G3,i1))*(-p2+MFd2(I3G3)))))
    	enddo
    	enddo

    	do I3G3 = 1,3
    	do I5G3 = 1,5
       self=self-2*(A0(MNeu2(I5G3))*(cchiupsumL(I5G3,I3G3,i1)*
     &  DCONJG(cchiupsumL(I5G3,I3G3,i2))+cchiupsumR(I5G3,I3G3,i1)*
     &  DCONJG(cchiupsumR(I5G3,I3G3,i2)))+cchiupsumR(I5G3,I3G3,i1)*(-
     &  (p2*DBLEN(B0i(bb1,p2,MNeu2(I5G3),MFu2(I3G3)))*
     &  DCONJG(cchiupsumR(I5G3,I3G3,i2)))+DBLEN(B0i(bb0,p2,MFu2(I3G3)
     &  ,MNeu2(I5G3)))*(DCONJG(cchiupsumR(I5G3,I3G3,i2))*(-p2+
     &  MFu2(I3G3))+DCONJG(cchiupsumL(I5G3,I3G3,i2))*MassFu(I3G3)*
     &  MNeu(I5G3)))+cchiupsumL(I5G3,I3G3,i1)*(-(p2*
     &  DBLEN(B0i(bb1,p2,MNeu2(I5G3),MFu2(I3G3)))*
     &  DCONJG(cchiupsumL(I5G3,I3G3,i2)))+DBLEN(B0i(bb0,p2,MFu2(I3G3)
     &  ,MNeu2(I5G3)))*(DCONJG(cchiupsumL(I5G3,I3G3,i2))*(-p2+
     &  MFu2(I3G3))+DCONJG(cchiupsumR(I5G3,I3G3,i2))*MassFu(I3G3)*MNeu(I5G3))))
    	enddo
    	enddo
    	do I6G3 = 1,6
       self=self+((IC*A0(Masshh2(I6G3))*ChhSupSum(i2,I6G3,i1,I6G3))
     &  /2.-A0(MSd2(I6G3))*(3*CSu2Sd2p1(i2,i1,I6G3,I6G3)+
     &  CSu2Sd2p2(i2,i1,I6G3,I6G3))-A0(MSe2(I6G3))*
     &  CSu2Se2(i2,i1,I6G3,I6G3)-A0(MSu2(I6G3))*
     &  CSu4p1(i2,I6G3,i1,I6G3)-3*A0(MSu2(I6G3))*
     &  CSu4p2(i2,I6G3,i1,I6G3)-A0(MZ2)*CsupsumZ(i2,I6G3)*
     &  CsupsumZ(I6G3,i1)-3*p2*CsupsumZ(i2,I6G3)*CsupsumZ(I6G3,i1)*
     &  DBLEN(B0i(bb0,p2,MZ2,MSu2(I6G3)))-2*p2*CsupsumZ(i2,I6G3)*
     &  CsupsumZ(I6G3,i1)*DBLEN(B0i(bb1,p2,MZ2,MSu2(I6G3)))-A0(MW2)*
     &  CsdsuW(I6G3,i1)*DCONJG(CsdsuW(I6G3,i2))-3*p2*CsdsuW(I6G3,i1)*
     &  DBLEN(B0i(bb0,p2,MW2,MSd2(I6G3)))*DCONJG(CsdsuW(I6G3,i2))-2*
     &  p2*CsdsuW(I6G3,i1)*DBLEN(B0i(bb1,p2,MW2,MSd2(I6G3)))*
     &  DCONJG(CsdsuW(I6G3,i2))-CsdsuW(I6G3,i1)*
     &  DBLEN(B0i(bb0,p2,MW2,MSd2(I6G3)))*DCONJG(CsdsuW(I6G3,i2))*
     &  MSd2(I6G3)-CsupsumZ(i2,I6G3)*CsupsumZ(I6G3,i1)*
     &  DBLEN(B0i(bb0,p2,MZ2,MSu2(I6G3)))*MSu2(I6G3))
    	enddo
    	do I2G3 = 1,2
    	do I6G3 = 1,6
       self=self-(CHmSupSdp(i2,I6G3,I2G3)*CHpSumSdm(I6G3,i1,I2G3)*
     &  DBLEN(B0i(bb0,p2,MassHpm2(I2G3),MSd2(I6G3))))
    	enddo
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       self=self-(ChSupSum(i2,I6G4,I6G3)*ChSupSum(I6G4,i1,I6G3)*
     &  DBLEN(B0i(bb0,p2,Masshh2(I6G3),MSu2(I6G4))))
    	enddo
    	enddo

        elseif(iew.eq.2)then
       self=self+(-4*g3**2*IndexDelta*(2*p2*
     &  DBLEN(B0i(bb1,p2,0D0,MSu2(i1)))+DBLEN(B0i(bb0,p2,0D0,MSu2(i1)))*
     &  (3*p2+MSu2(i1))))/3.

c       self=self+(-4*g3**2*IndexDelta*(2*p2*
c     &  DBLEN(B0i(bb1,p2,0D0,P2))+DBLEN(B0i(bb0,p2,0D0,P2))*
c     &  (3*p2+P2)))/3.
    	do I3G3 = 1,3
       self=self+(-8*g3**2*(A0(MGL2)*(CF15usuL(I3G3,i1)*
     &  DCONJG(CF15usuL(I3G3,i2))+CF15usuR(I3G3,i1)*
     &  DCONJG(CF15usuR(I3G3,i2)))+CF15usuL(I3G3,i1)*(p2*
     &  DBLEN(B0i(bb1,p2,MFu2(I3G3),MGL2))*DCONJG(CF15usuL(I3G3,i2))+
     &  DBLEN(B0i(bb0,p2,MGL2,MFu2(I3G3)))*(-(DCONJG(CF15usuR(I3G3,i2)
     &  )*MassFu(I3G3)*MGL)+DCONJG(CF15usuL(I3G3,i2))*
     &  MFu2(I3G3)))+CF15usuR(I3G3,i1)*(p2*DBLEN(B0i(bb1,p2,MFu2(I3G3)
     &  ,MGL2))*DCONJG(CF15usuR(I3G3,i2))+
     &  DBLEN(B0i(bb0,p2,MGL2,MFu2(I3G3)))*(-(DCONJG(CF15usuL(I3G3,i2)
     &  )*MassFu(I3G3)*MGL)+DCONJG(CF15usuR(I3G3,i2))*
     &  MFu2(I3G3)))))/3.
    	enddo

    	do I6G3 = 1,6
       self=self-(g3**2*(A0(MSd2(I6G3))*(3*CSu2Sd2p1QCD(i2,i1,I6G3,I6G3)
     &  +CSu2Sd2p2QCD(i2,i1,I6G3,I6G3))+A0(MSu2(I6G3))*
     &  (CSu4p1QCD(i2,I6G3,i1,I6G3)+3*CSu4p2QCD(i2,I6G3,i1,I6G3))))
    	enddo
        endif

        self=self*fac
      end Subroutine SelfStopFull

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Subroutine DSelfStop(P2,i1,i2,Dself,iew,iuv)
      implicit none
#include "looptools.h"  
      integer i,igen,gt1,gt2,gt3,gt4,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3,I3G5,i1,i2,IndexDelta,
     &          iew,iuv

      double precision Q,P2,MGL,MGL2,divergence
      double precision absM3, phiM3
      common /gluino/ absM3,phiM3

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta    
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
   
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta

      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv


      double complex IC,Dself,x
#include "HdecayTCLs.inc"
      if(iuv.eq.1)then
       Dself=0D0
       return
      endif

        IC=(0,1D0)
        MGL=absM3;MGL2=MGL**2
       if (i1.eq.i2) then
        IndexDelta=1
       else 
        IndexDelta=0
       endif

       Dself=0D0
       if (iew.eq.1)then
c We haved changed msu(i)^2 to P2
       Dself=Dself+(-4*e**2*IndexDelta*(3*
     &  DBLEK(B0i(bb0,p2,0D0,P2))+2*DBLEK(B0i(bb1,p2,0D0,P2))
     &  +3*p2*DBLEK(B0i(dbb0,p2,0D0,P2))+2*p2*
     &  DBLEK(B0i(dbb1,p2,0D0,P2))+DBLEK(B0i(dbb0,p2,0D0,P2))
     &  *P2))/9.
c        print*, Dself- (8*e**2)*((log(getlambda())))/9D0

    	do I2G3 = 1,2
    	do I3G3 = 1,3
       Dself=Dself+2*(cdmchapsuL(I3G3,I2G3,i2)*
     &  (DBLEK(B0i(bb0,p2,MCha2(I2G3),MFd2(I3G3)))*
     &  DCONJG(cdmchapsuL(I3G3,I2G3,i1))+DBLEK(B0i(bb1,p2,MCha2(I2G3)
     &  ,MFd2(I3G3)))*DCONJG(cdmchapsuL(I3G3,I2G3,i1))+p2*
     &  DBLEK(B0i(dbb0,p2,MCha2(I2G3),MFd2(I3G3)))*
     &  DCONJG(cdmchapsuL(I3G3,I2G3,i1))+p2*
     &  DBLEK(B0i(dbb1,p2,MCha2(I2G3),MFd2(I3G3)))*
     &  DCONJG(cdmchapsuL(I3G3,I2G3,i1))-DBLEK(B0i(dbb0,p2,MCha2(I2G3)
     &  ,MFd2(I3G3)))*DCONJG(cdmchapsuR(I3G3,I2G3,i1))*MassFd(I3G3)*
     &  MCha(I2G3)-DBLEK(B0i(dbb0,p2,MCha2(I2G3),MFd2(I3G3)))*
     &  DCONJG(cdmchapsuL(I3G3,I2G3,i1))*MFd2(I3G3))+
     &  cdmchapsuR(I3G3,I2G3,i2)*(DBLEK(B0i(bb0,p2,MCha2(I2G3)
     &  ,MFd2(I3G3)))*DCONJG(cdmchapsuR(I3G3,I2G3,i1))+
     &  DBLEK(B0i(bb1,p2,MCha2(I2G3),MFd2(I3G3)))*
     &  DCONJG(cdmchapsuR(I3G3,I2G3,i1))+p2*
     &  DBLEK(B0i(dbb0,p2,MCha2(I2G3),MFd2(I3G3)))*
     &  DCONJG(cdmchapsuR(I3G3,I2G3,i1))+p2*
     &  DBLEK(B0i(dbb1,p2,MCha2(I2G3),MFd2(I3G3)))*
     &  DCONJG(cdmchapsuR(I3G3,I2G3,i1))-DBLEK(B0i(dbb0,p2,MCha2(I2G3)
     &  ,MFd2(I3G3)))*DCONJG(cdmchapsuL(I3G3,I2G3,i1))*MassFd(I3G3)*
     &  MCha(I2G3)-DBLEK(B0i(dbb0,p2,MCha2(I2G3),MFd2(I3G3)))*
     &  DCONJG(cdmchapsuR(I3G3,I2G3,i1))*MFd2(I3G3)))
    	enddo
    	enddo
    	do I3G3 = 1,3
    	do I5G3 = 1,5
       Dself=Dself+2*(cchiupsumR(I5G3,I3G3,i1)*
     &  (DBLEK(B0i(bb0,p2,MFu2(I3G3),MNeu2(I5G3)))*
     &  DCONJG(cchiupsumR(I5G3,I3G3,i2))+DBLEK(B0i(bb1,p2,MNeu2(I5G3)
     &  ,MFu2(I3G3)))*DCONJG(cchiupsumR(I5G3,I3G3,i2))+p2*
     &  DBLEK(B0i(dbb0,p2,MFu2(I3G3),MNeu2(I5G3)))*
     &  DCONJG(cchiupsumR(I5G3,I3G3,i2))+p2*
     &  DBLEK(B0i(dbb1,p2,MNeu2(I5G3),MFu2(I3G3)))*
     &  DCONJG(cchiupsumR(I5G3,I3G3,i2))-DBLEK(B0i(dbb0,p2,MFu2(I3G3)
     &  ,MNeu2(I5G3)))*DCONJG(cchiupsumR(I5G3,I3G3,i2))*MFu2(I3G3)-
     &  DBLEK(B0i(dbb0,p2,MFu2(I3G3),MNeu2(I5G3)))*
     &  DCONJG(cchiupsumL(I5G3,I3G3,i2))*MassFu(I3G3)*MNeu(I5G3))+
     &  cchiupsumL(I5G3,I3G3,i1)*(DBLEK(B0i(bb0,p2,MFu2(I3G3)
     &  ,MNeu2(I5G3)))*DCONJG(cchiupsumL(I5G3,I3G3,i2))+
     &  DBLEK(B0i(bb1,p2,MNeu2(I5G3),MFu2(I3G3)))*
     &  DCONJG(cchiupsumL(I5G3,I3G3,i2))+p2*
     &  DBLEK(B0i(dbb0,p2,MFu2(I3G3),MNeu2(I5G3)))*
     &  DCONJG(cchiupsumL(I5G3,I3G3,i2))+p2*
     &  DBLEK(B0i(dbb1,p2,MNeu2(I5G3),MFu2(I3G3)))*
     &  DCONJG(cchiupsumL(I5G3,I3G3,i2))-DBLEK(B0i(dbb0,p2,MFu2(I3G3)
     &  ,MNeu2(I5G3)))*DCONJG(cchiupsumL(I5G3,I3G3,i2))*MFu2(I3G3)-
     &  DBLEK(B0i(dbb0,p2,MFu2(I3G3),MNeu2(I5G3)))*
     &  DCONJG(cchiupsumR(I5G3,I3G3,i2))*MassFu(I3G3)*MNeu(I5G3)))
    	enddo
    	enddo
    	do I6G3 = 1,6
       Dself=Dself+(-(CsdsuW(I6G3,i1)*DCONJG(CsdsuW(I6G3,i2))*(3*
     &  DBLEK(B0i(bb0,p2,MW2,MSd2(I6G3)))+2*
     &  DBLEK(B0i(bb1,p2,MW2,MSd2(I6G3)))+3*p2*
     &  DBLEK(B0i(dbb0,p2,MW2,MSd2(I6G3)))+2*p2*
     &  DBLEK(B0i(dbb1,p2,MW2,MSd2(I6G3)))+
     &  DBLEK(B0i(dbb0,p2,MW2,MSd2(I6G3)))*MSd2(I6G3)))-
     &  CsupsumZ(i2,I6G3)*CsupsumZ(I6G3,i1)*(3*
     &  DBLEK(B0i(bb0,p2,MZ2,MSu2(I6G3)))+2*
     &  DBLEK(B0i(bb1,p2,MZ2,MSu2(I6G3)))+3*p2*
     &  DBLEK(B0i(dbb0,p2,MZ2,MSu2(I6G3)))+2*p2*
     &  DBLEK(B0i(dbb1,p2,MZ2,MSu2(I6G3)))+DBLEK(B0i(dbb0,p2,MZ2,MSu2(I6G3)))*MSu2(I6G3)))
    	enddo
    	do I2G3 = 1,2
    	do I6G3 = 1,6
       Dself=Dself-(CHmSupSdp(i2,I6G3,I2G3)*CHpSumSdm(I6G3,i1,I2G3)*
     &  DBLEK(B0i(dbb0,p2,MassHpm2(I2G3),MSd2(I6G3))))
    	enddo
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       Dself=Dself-(ChSupSum(i2,I6G4,I6G3)*ChSupSum(I6G4,i1,I6G3)*
     &  DBLEK(B0i(dbb0,p2,Masshh2(I6G3),MSu2(I6G4))))
    	enddo
    	enddo
       elseif(iew.eq.2)then
       Dself=Dself+(-4*g3**2*IndexDelta*(3*DBLEK(B0i(bb0,p2,0D0,P2
     &  ))+2*DBLEK(B0i(bb1,p2,0D0,P2))+4*p2*
     &  DBLEK(B0i(dbb0,p2,0D0,P2))+2*p2*
     &  DBLEK(B0i(dbb1,p2,0D0,P2)) ))/3.
c nhung test 
c        print*, Dself- (8*g3**2)*((log(getlambda())))/3D0
c        stop
    	do I3G3 = 1,3
       Dself=Dself+(-8*g3**2*(CF15usuL(I3G3,i1)*
     &  (DBLEK(B0i(bb1,p2,MFu2(I3G3),MGL2))*DCONJG(CF15usuL(I3G3,i2))+
     &  p2*DBLEK(B0i(dbb1,p2,MFu2(I3G3),MGL2))*
     &  DCONJG(CF15usuL(I3G3,i2))+DBLEK(B0i(dbb0,p2,MGL2,MFu2(I3G3)))*
     &  (-(DCONJG(CF15usuR(I3G3,i2))*MassFu(I3G3)*MGL)+
     &  DCONJG(CF15usuL(I3G3,i2))*MFu2(I3G3)))+CF15usuR(I3G3,i1)*
     &  (DBLEK(B0i(bb1,p2,MFu2(I3G3),MGL2))*DCONJG(CF15usuR(I3G3,i2))+
     &  p2*DBLEK(B0i(dbb1,p2,MFu2(I3G3),MGL2))*
     &  DCONJG(CF15usuR(I3G3,i2))+DBLEK(B0i(dbb0,p2,MGL2,MFu2(I3G3)))*
     &  (-(DCONJG(CF15usuL(I3G3,i2))*MassFu(I3G3)*MGL)+
     &  DCONJG(CF15usuR(I3G3,i2))*MFu2(I3G3)))))/3.
    	enddo
       endif
       Dself=Dself*fac

      end Subroutine DSelfStop
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	Subroutine Selftop(P2,i1,i2,selfT,iew,iUV)
        implicit none
#include "looptools.h"  
	integer i,igen,gt1,gt2,gt3,gt4,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3,I3G5,i1,i2,IndexDelta,
     &          iew,iUV

        double precision Q,P2,MGL,MGL2,divergence
        

      double precision absM3, phiM3
      common /gluino/ absM3,phiM3
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta 
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)  
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      double complex IC,selfT(4)

#include "HdecayTCLs.inc"

c nhung tested the two options give the same value for dmf(i1,i1) because
c only t->bW is open then only diagram with b, W boson in loop contain
c Imaginary part of the loop integral, but the couplings are real
c so there is no contribution of type Im(loop integral)* Im(couplings)
      if (iuv.eq.1)then
        selfT(1:4)=0D0
        return
      endif

        IC=(0,1D0)
        MGL=absM3;MGL2=MGL**2
       if (i1.eq.i2) then
        IndexDelta=1
       else 
        IndexDelta=0
       endif
	ZP(1,1) = -Cos(beta);ZP(1,2) = Sin(beta)
	ZP(2,1) = Sin(beta);ZP(2,2) = Cos(beta)
        selfT(1:4)=0D0

       if(iew.eq.1)then
       selfT(1)=((16*e**2*(DBLEK(B0i(bb0,p2,0D0,MFu2(i1)))+
     &  DBLEK(B0i(bb1,p2,0D0,MFu2(i1))))+18*g2**2*
     &  (DBLEK(B0i(bb0,p2,MW2,MFd2(i1)))+DBLEK(B0i(bb1,p2,MW2,MFd2(i1))
     &  ))+(9*CW2*g2**2+g1*(-6*CW*g2*SW+g1*SW2))*
     &  (DBLEK(B0i(bb0,p2,MZ2,MFu2(i1)))+DBLEK(B0i(bb1,p2,MZ2,MFu2(i1))
     &  )))*IndexDelta)/18.+selfT(1)

       selfT(2)=(8*(e**2*DBLEK(B0i(bb0,p2,0D0,MFu2(i1)))+g1**2*SW2*
     &  DBLEK(B0i(bb0,p2,MZ2,MFu2(i1)))+e**2*
     &  DBLEK(B0i(bb1,p2,0D0,MFu2(i1)))+g1**2*SW2*
     &  DBLEK(B0i(bb1,p2,MZ2,MFu2(i1))))*IndexDelta)/9.+selfT(2)
        

       selfT(3)=(-4*(4*e**2*DBLEK(B0i(bb0,p2,0D0,MFu2(i1)))+g1*(-3*CW*g2*
     &  SW+g1*SW2)*DBLEK(B0i(bb0,p2,MZ2,MFu2(i1))))*IndexDelta*
     &  MassFu(i1))/9.+selfT(3)
       selfT(4)=(-4*(4*e**2*DBLEK(B0i(bb0,p2,0D0,MFu2(i1)))+g1*(-3*CW*g2*
     &  SW+g1*SW2)*DBLEK(B0i(bb0,p2,MZ2,MFu2(i1))))*IndexDelta*
     &  MassFu(i1))/9.+selfT(4)

    	do I2G3 = 1,2
       selfT(1)=selfT(1)-(DBLEK(B0i(bb1,p2,MFd2(i1),MassHpm2(I2G3)))*
     &  IndexDelta*Yd(i1)*Yd(i2)*ZP(I2G3,1)**2)
       selfT(2)=selfT(2)-(DBLEK(B0i(bb1,p2,MFd2(i1),MassHpm2(I2G3)))*
     &  IndexDelta*Yu(i1)*Yu(i2)*ZP(I2G3,2)**2)
       selfT(3)=selfT(3)+DBLEK(B0i(bb0,p2,MassHpm2(I2G3),MFd2(i1)))*
     &  IndexDelta*MassFd(i1)*Yd(i1)*Yu(i2)*ZP(I2G3,1)*
     &  ZP(I2G3,2)
       selfT(4)=selfT(4)+DBLEK(B0i(bb0,p2,MassHpm2(I2G3),MFd2(i1)))*
     &  IndexDelta*MassFd(i1)*Yd(i2)*Yu(i1)*ZP(I2G3,1)*
     &  ZP(I2G3,2)
    	enddo

    	do I6G3 = 1,6
       selfT(1)=CLhFumFup(i1,i1,I6G3)*CRhFumFup(i2,i1,I6G3)*
     &  DBLEK(B0i(bb1,p2,MFu2(i1),Masshh2(I6G3)))*IndexDelta+
     &  selfT(1)
       selfT(2)=CLhFumFup(i2,i1,I6G3)*CRhFumFup(i1,i1,I6G3)*
     &  DBLEK(B0i(bb1,p2,MFu2(i1),Masshh2(I6G3)))*IndexDelta+
     &  selfT(2)
       selfT(3)=-(CLhFumFup(i1,i1,I6G3)*CLhFumFup(i2,i1,I6G3)*
     &  DBLEK(B0i(bb0,p2,Masshh2(I6G3),MFu2(i1)))*IndexDelta*
     &  MassFu(i1))+selfT(3)
       selfT(4)=-(CRhFumFup(i1,i1,I6G3)*CRhFumFup(i2,i1,I6G3)*
     &  DBLEK(B0i(bb0,p2,Masshh2(I6G3),MFu2(i1)))*IndexDelta*
     &  MassFu(i1))+selfT(4)
    	enddo

    	do I2G3 = 1,2
    	do I6G3 = 1,6
       selfT(1)=-(cupchapsdL(I2G3,i1,I6G3)*DBLEK(B0i(bb1,p2,MCha2(I2G3)
     &  ,MSd2(I6G3)))*DCONJG(cupchapsdL(I2G3,i2,I6G3)))+selfT(1)
       selfT(2)=-(cupchapsdR(I2G3,i1,I6G3)*DBLEK(B0i(bb1,p2,MCha2(I2G3)
     &  ,MSd2(I6G3)))*DCONJG(cupchapsdR(I2G3,i2,I6G3)))+selfT(2)
       selfT(3)=cupchapsdL(I2G3,i1,I6G3)*DBLEK(B0i(bb0,p2,MCha2(I2G3)
     &  ,MSd2(I6G3)))*DCONJG(cupchapsdR(I2G3,i2,I6G3))*MCha(I2G3)+
     &  selfT(3)
       selfT(4)=cupchapsdR(I2G3,i1,I6G3)*DBLEK(B0i(bb0,p2,MCha2(I2G3)
     &  ,MSd2(I6G3)))*DCONJG(cupchapsdL(I2G3,i2,I6G3))*MCha(I2G3)+
     &  selfT(4)
    	enddo
    	enddo


    	do I5G3 = 1,5
    	do I6G3 = 1,6
       selfT(1)=-(cchiupsumL(I5G3,i1,I6G3)*DBLEK(B0i(bb1,p2,MNeu2(I5G3)
     &  ,MSu2(I6G3)))*DCONJG(cchiupsumL(I5G3,i2,I6G3)))+selfT(1)
       selfT(2)=-(cchiupsumR(I5G3,i1,I6G3)*DBLEK(B0i(bb1,p2,MNeu2(I5G3)
     &  ,MSu2(I6G3)))*DCONJG(cchiupsumR(I5G3,i2,I6G3)))+selfT(2)
       selfT(3)=cchiupsumL(I5G3,i1,I6G3)*DBLEK(B0i(bb0,p2,MNeu2(I5G3)
     &  ,MSu2(I6G3)))*DCONJG(cchiupsumR(I5G3,i2,I6G3))*MNeu(I5G3)+
     &  selfT(3)
       selfT(4)=cchiupsumR(I5G3,i1,I6G3)*DBLEK(B0i(bb0,p2,MNeu2(I5G3)
     &  ,MSu2(I6G3)))*DCONJG(cchiupsumL(I5G3,i2,I6G3))*MNeu(I5G3)+
     &  selfT(4)
    	enddo
    	enddo

       elseif(iew.eq.2)then
       selfT(1)=(8*g3**2*IndexDelta*(DBLEK(B0i(bb0,p2,0D0,MFu2(i1)))+
     &  DBLEK(B0i(bb1,p2,0D0,MFu2(i1)))))/3.+selfT(1)
       selfT(2)=(8*g3**2*IndexDelta*(DBLEK(B0i(bb0,p2,0D0,MFu2(i1)))+
     &  DBLEK(B0i(bb1,p2,0D0,MFu2(i1)))))/3.+selfT(2)
       selfT(3)=(-16*g3**2*IndexDelta*DBLEK(B0i(bb0,p2,0D0,MFu2(i1)))*
     &  MassFu(i1))/3.+selfT(3)
       selfT(4)=(-16*g3**2*IndexDelta*DBLEK(B0i(bb0,p2,0D0,MFu2(i1)))*
     &  MassFu(i1))/3.+selfT(4)
    	do I6G3 = 1,6
       selfT(1)=(-4*g3**2*CF15usuL(i1,I6G3)*
     &  DBLEK(B0i(bb1,p2,MGL2,MSu2(I6G3)))*DCONJG(CF15usuL(i2,I6G3)))
     &  /3.+selfT(1)
       selfT(2)=(-4*g3**2*CF15usuR(i1,I6G3)*
     &  DBLEK(B0i(bb1,p2,MGL2,MSu2(I6G3)))*DCONJG(CF15usuR(i2,I6G3)))
     &  /3.+selfT(2)
       selfT(3)=(-4*g3**2*CF15usuL(i1,I6G3)*
     &  DBLEK(B0i(bb0,p2,MGL2,MSu2(I6G3)))*DCONJG(CF15usuR(i2,I6G3))*
     &  MGL)/3.+selfT(3)
       selfT(4)=(-4*g3**2*CF15usuR(i1,I6G3)*
     &  DBLEK(B0i(bb0,p2,MGL2,MSu2(I6G3)))*DCONJG(CF15usuL(i2,I6G3))*
     &  MGL)/3.+selfT(4)
    	enddo
       endif

       selfT(1:4)=       selfT(1:4)*fac

       end Subroutine Selftop

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Subroutine Selfbottom(P2,i1,i2,selfB,iew,iuv)
      implicit none
#include "looptools.h"  
      integer i,igen,gt1,gt2,gt3,gt4,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3,I3G5,i1,i2,IndexDelta,
     &          iew,iuv

      double precision Q,P2,MGL,MGL2,divergence  

      double precision absM3, phiM3
      common /gluino/ absM3,phiM3

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
    
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)

      double precision ZH5(5,5),ZH(6,6)    
      double complex UM(2,2),UP(2,2),NN(5,5),ZEN(6,6),ZDN(6,6),ZUN(6,6)
  
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv

      double complex IC,selfB(4)

#include "HdecayTCLs.inc"
c nhung tested the two options give the same value for dmf(i1,i1) because
c so there is no contribution of type Im(loop integral)* Im(couplings)
      if(iuv.eq.1)then
        selfB(1:4)=0D0
        return
      endif
        IC=(0,1D0)
        MGL=absM3;MGL2=MGL**2
       if (i1.eq.i2) then
        IndexDelta=1
       else 
        IndexDelta=0
       endif

       selfB(1:4)=0D0

       if(iew.eq.1)then
       selfB(1)=(IndexDelta*(4*e**2*(DBLEK(B0i(bb0,p2,0D0,MFd2(i1)))+
     &  DBLEK(B0i(bb1,p2,0D0,MFd2(i1))))+18*g2**2*
     &  (DBLEK(B0i(bb0,p2,MW2,MFu2(i1)))+DBLEK(B0i(bb1,p2,MW2,MFu2(i1))
     &  ))+(9*CW2*g2**2+g1*(6*CW*g2*SW+g1*SW2))*
     &  (DBLEK(B0i(bb0,p2,MZ2,MFd2(i1)))+DBLEK(B0i(bb1,p2,MZ2,MFd2(i1))
     &  ))))/18.+selfB(1)
       selfB(2)=(2*IndexDelta*(e**2*DBLEK(B0i(bb0,p2,0D0,MFd2(i1)))+g1**
     &  2*SW2*DBLEK(B0i(bb0,p2,MZ2,MFd2(i1)))+e**2*
     &  DBLEK(B0i(bb1,p2,0D0,MFd2(i1)))+g1**2*SW2*
     &  DBLEK(B0i(bb1,p2,MZ2,MFd2(i1)))))/9.+selfB(2)
       selfB(3)=(-2*IndexDelta*(2*e**2*DBLEK(B0i(bb0,p2,0D0,MFd2(i1)))-
     &  g1*(3*CW*g2*SW+g1*SW2)*DBLEK(B0i(bb0,p2,MZ2,MFd2(i1))))*
     &  MassFd(i1))/9.+selfB(3)
       selfB(4)=(-2*IndexDelta*(2*e**2*DBLEK(B0i(bb0,p2,0D0,MFd2(i1)))-
     &  g1*(3*CW*g2*SW+g1*SW2)*DBLEK(B0i(bb0,p2,MZ2,MFd2(i1))))*
     &  MassFd(i1))/9.+selfB(4)

    	do I2G3 = 1,2
       selfB(1)=selfB(1)-(DBLEK(B0i(bb1,p2,MFu2(i1),MassHpm2(I2G3)))*
     &  IndexDelta*Yu(i1)*Yu(i2)*ZP(I2G3,2)**2)
       selfB(2)=selfB(2)-(IndexDelta*DBLEK(B0i(bb1,p2,MFu2(i1)
     &  ,MassHpm2(I2G3)))*Yd(i1)*Yd(i2)*ZP(I2G3,1)**2)
       selfB(3)=selfB(3)+IndexDelta*DBLEK(B0i(bb0,p2,MassHpm2(I2G3)
     &  ,MFu2(i1)))*MassFu(i1)*Yd(i2)*Yu(i1)*ZP(I2G3,1)*ZP(I2G3,2)
       selfB(4)=selfB(4)+IndexDelta*DBLEK(B0i(bb0,p2,MassHpm2(I2G3)
     &  ,MFu2(i1)))*MassFu(i1)*Yd(i1)*Yu(i2)*ZP(I2G3,1)*ZP(I2G3,2)
    	enddo


    	do I6G3 = 1,6
       selfB(1)=CLhFdpFdm(i1,i1,I6G3)*CRhFdpFdm(i2,i1,I6G3)*
     &  DBLEK(B0i(bb1,p2,MFd2(i1),Masshh2(I6G3)))*IndexDelta+
     &  selfB(1)
       selfB(2)=IndexDelta*CLhFdpFdm(i2,i1,I6G3)*CRhFdpFdm(i1,i1,I6G3)*
     &  DBLEK(B0i(bb1,p2,MFd2(i1),Masshh2(I6G3)))+selfB(2)
       selfB(3)=-(IndexDelta*CLhFdpFdm(i1,i1,I6G3)*
     &  CLhFdpFdm(i2,i1,I6G3)*DBLEK(B0i(bb0,p2,Masshh2(I6G3),MFd2(i1)))
     &  *MassFd(i1))+selfB(3)
       selfB(4)=-(IndexDelta*CRhFdpFdm(i1,i1,I6G3)*
     &  CRhFdpFdm(i2,i1,I6G3)*DBLEK(B0i(bb0,p2,Masshh2(I6G3),MFd2(i1)))
     &  *MassFd(i1))+selfB(4)
    	enddo


    	do I2G3 = 1,2
    	do I6G3 = 1,6
       selfB(1)=-(cdmchapsuR(i2,I2G3,I6G3)*DBLEK(B0i(bb1,p2,MCha2(I2G3)
     &  ,MSu2(I6G3)))*DCONJG(cdmchapsuR(i1,I2G3,I6G3)))+selfB(1)
       selfB(2)=-(cdmchapsuL(i2,I2G3,I6G3)*DBLEK(B0i(bb1,p2,MCha2(I2G3)
     &  ,MSu2(I6G3)))*DCONJG(cdmchapsuL(i1,I2G3,I6G3)))+selfB(2)
       selfB(3)=cdmchapsuL(i2,I2G3,I6G3)*DBLEK(B0i(bb0,p2,MCha2(I2G3)
     &  ,MSu2(I6G3)))*DCONJG(cdmchapsuR(i1,I2G3,I6G3))*MCha(I2G3)+
     &  selfB(3)
       selfB(4)=cdmchapsuR(i2,I2G3,I6G3)*DBLEK(B0i(bb0,p2,MCha2(I2G3)
     &  ,MSu2(I6G3)))*DCONJG(cdmchapsuL(i1,I2G3,I6G3))*MCha(I2G3)+
     &  selfB(4)
    	enddo
    	enddo

    	do I5G3 = 1,5
    	do I6G3 = 1,6
       selfB(1)=-(cchidmsdpL(I5G3,i1,I6G3)*DBLEK(B0i(bb1,p2,MNeu2(I5G3)
     &  ,MSd2(I6G3)))*DCONJG(cchidmsdpL(I5G3,i2,I6G3)))+selfB(1)
       selfB(2)=-(cchidmsdpR(I5G3,i1,I6G3)*DBLEK(B0i(bb1,p2,MNeu2(I5G3)
     &  ,MSd2(I6G3)))*DCONJG(cchidmsdpR(I5G3,i2,I6G3)))+selfB(2)
       selfB(3)=cchidmsdpL(I5G3,i1,I6G3)*DBLEK(B0i(bb0,p2,MNeu2(I5G3)
     &  ,MSd2(I6G3)))*DCONJG(cchidmsdpR(I5G3,i2,I6G3))*MNeu(I5G3)+
     &  selfB(3)
       selfB(4)=cchidmsdpR(I5G3,i1,I6G3)*DBLEK(B0i(bb0,p2,MNeu2(I5G3)
     &  ,MSd2(I6G3)))*DCONJG(cchidmsdpL(I5G3,i2,I6G3))*MNeu(I5G3)+
     &  selfB(4)
    	enddo
    	enddo
       elseif(iew.eq.2)then
       selfB(1)=(8*g3**2*IndexDelta*(DBLEK(B0i(bb0,p2,0D0,MFd2(i1)))+
     &  DBLEK(B0i(bb1,p2,0D0,MFd2(i1)))))/3.+selfB(1)
       selfB(2)=(8*g3**2*IndexDelta*(DBLEK(B0i(bb0,p2,0D0,MFd2(i1)))+
     &  DBLEK(B0i(bb1,p2,0D0,MFd2(i1)))))/3.+selfB(2)
       selfB(3)=(-16*g3**2*IndexDelta*DBLEK(B0i(bb0,p2,0D0,MFd2(i1)))*
     &  MassFd(i1))/3.+selfB(3)
       selfB(4)=(-16*g3**2*IndexDelta*DBLEK(B0i(bb0,p2,0D0,MFd2(i1)))*
     &  MassFd(i1))/3.+selfB(4)
    	do I6G3 = 1,6
       selfB(1)=(-4*g3**2*CF15dsdL(i1,I6G3)*
     &  DBLEK(B0i(bb1,p2,MGL2,MSd2(I6G3)))*DCONJG(CF15dsdL(i2,I6G3)))
     &  /3.+selfB(1)
       selfB(2)=(-4*g3**2*CF15dsdR(i1,I6G3)*
     &  DBLEK(B0i(bb1,p2,MGL2,MSd2(I6G3)))*DCONJG(CF15dsdR(i2,I6G3)))
     &  /3.+selfB(2)
       selfB(3)=(-4*g3**2*CF15dsdL(i1,I6G3)*
     &  DBLEK(B0i(bb0,p2,MGL2,MSd2(I6G3)))*DCONJG(CF15dsdR(i2,I6G3))*
     &  MGL)/3.+selfB(3)
       selfB(4)=(-4*g3**2*CF15dsdR(i1,I6G3)*
     &  DBLEK(B0i(bb0,p2,MGL2,MSd2(I6G3)))*DCONJG(CF15dsdL(i2,I6G3))*
     &  MGL)/3.+selfB(4)
    	enddo
       endif
       selfB(1:4)= selfB(1:4)*fac

      end Subroutine Selfbottom

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Subroutine SelfSbottom(P2,i1,i2,self,iew,iuv)
      implicit none
#include "looptools.h"  
      integer i,igen,gt1,gt2,gt3,gt4,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3,I3G5,i1,i2,IndexDelta,
     &          iew,iuv
      double precision Q,P2,MGL,MGL2,divergence
        
      double precision absM3, phiM3
      common /gluino/ absM3,phiM3

      double precision Qs

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3   
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      common /scale/ Qs      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3

      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv


      double complex IC,self
#include "HdecayTCLs.inc"
      if(iuv.eq.1)then
       self=0D0
       return
      endif

        MGL=absM3;MGL2=MGL**2
        IC=(0,1D0)
       if (i1.eq.i2) then
        IndexDelta=1
       else 
        IndexDelta=0
       endif

       self=0D0

       if(iew.eq.1)then
       self=(36*A0(MW2)*CSdSdWW(i2,i1)+18*A0(MZ2)*CSdSdZZ(i2,i1)
     &  -IndexDelta* e**2*(2*p2*DBLEK(B0i(bb1,p2,0D0,MSd2(i1)))+
     &  DBLEK(B0i(bb0,p2,0D0,MSd2(i1)))*(3*p2+MSd2(i1))))/9.

    	do I2G3 = 1,2
       self=self+IC*A0(MassHpm2(I2G3))*CHmHpSdmSdp(i2,I2G3,i1,I2G3)
    	enddo

    	do I3G3 = 1,3
       self=self-(A0(MSv2(I3G3))*CSd2Sv2(i2,i1,I3G3))
    	enddo
    	do I2G3 = 1,2
    	do I3G3 = 1,3
       self=self-2*(A0(MCha2(I2G3))*(cupchapsdL(I2G3,I3G3,i1)*
     &  DCONJG(cupchapsdL(I2G3,I3G3,i2))+cupchapsdR(I2G3,I3G3,i1)*
     &  DCONJG(cupchapsdR(I2G3,I3G3,i2)))+cupchapsdL(I2G3,I3G3,i1)*(-
     &  (p2*DBLEK(B0i(bb1,p2,MCha2(I2G3),MFu2(I3G3)))*
     &  DCONJG(cupchapsdL(I2G3,I3G3,i2)))+DBLEK(B0i(bb0,p2,MCha2(I2G3)
     &  ,MFu2(I3G3)))*(DCONJG(cupchapsdR(I2G3,I3G3,i2))*MassFu(I3G3)*
     &  MCha(I2G3)+DCONJG(cupchapsdL(I2G3,I3G3,i2))*(-p2+MFu2(I3G3))))+
     &  cupchapsdR(I2G3,I3G3,i1)*(-(p2*DBLEK(B0i(bb1,p2,MCha2(I2G3)
     &  ,MFu2(I3G3)))*DCONJG(cupchapsdR(I2G3,I3G3,i2)))+
     &  DBLEK(B0i(bb0,p2,MCha2(I2G3),MFu2(I3G3)))*
     &  (DCONJG(cupchapsdL(I2G3,I3G3,i2))*MassFu(I3G3)*Sqrt(MCha2(I2G3))+
     &  DCONJG(cupchapsdR(I2G3,I3G3,i2))*(-p2+MFu2(I3G3)))))
    	enddo
    	enddo

    	do I3G3 = 1,3
    	do I5G3 = 1,5
       self=self-2*(A0(MNeu2(I5G3))*(cchidmsdpL(I5G3,I3G3,i1)*
     &  DCONJG(cchidmsdpL(I5G3,I3G3,i2))+cchidmsdpR(I5G3,I3G3,i1)*
     &  DCONJG(cchidmsdpR(I5G3,I3G3,i2)))+cchidmsdpR(I5G3,I3G3,i1)*(-
     &  (p2*DBLEK(B0i(bb1,p2,MNeu2(I5G3),MFd2(I3G3)))*
     &  DCONJG(cchidmsdpR(I5G3,I3G3,i2)))+DBLEK(B0i(bb0,p2,MFd2(I3G3)
     &  ,MNeu2(I5G3)))*(DCONJG(cchidmsdpR(I5G3,I3G3,i2))*(-p2+
     &  MFd2(I3G3))+DCONJG(cchidmsdpL(I5G3,I3G3,i2))*MassFd(I3G3)*
     &  MNeu(I5G3)))+cchidmsdpL(I5G3,I3G3,i1)*(-(p2*
     &  DBLEK(B0i(bb1,p2,MNeu2(I5G3),MFd2(I3G3)))*
     &  DCONJG(cchidmsdpL(I5G3,I3G3,i2)))+DBLEK(B0i(bb0,p2,MFd2(I3G3)
     &  ,MNeu2(I5G3)))*(DCONJG(cchidmsdpL(I5G3,I3G3,i2))*(-p2+
     &  MFd2(I3G3))+DCONJG(cchidmsdpR(I5G3,I3G3,i2))*MassFd(I3G3)*MNeu(I5G3))))
    	enddo
    	enddo

c        print*,  'without sfermion', self*fac
c           self=0D0
    	do I6G3 = 1,6
       self=self+((IC*A0(Masshh2(I6G3))*ChhSdmSdp(i2,I6G3,i1,I6G3))
     &  /2.-A0(MSe2(I6G3))*CSd2Se2(i2,i1,I6G3,I6G3)-A0(MSd2(I6G3))*
     &  CSd4p1(i2,I6G3,i1,I6G3)-3*A0(MSd2(I6G3))*
     &  CSd4p2(i2,I6G3,i1,I6G3)-A0(MZ2)*CsdmsdpZ(i2,I6G3)*
     &  CsdmsdpZ(I6G3,i1)-3*A0(MSu2(I6G3))*CSu2Sd2p1(I6G3,I6G3,i2,i1)-
     &  A0(MSu2(I6G3))*CSu2Sd2p2(I6G3,I6G3,i2,i1)-3*p2*
     &  CsdmsdpZ(i2,I6G3)*CsdmsdpZ(I6G3,i1)*
     &  DBLEK(B0i(bb0,p2,MZ2,MSd2(I6G3)))-2*p2*CsdmsdpZ(i2,I6G3)*
     &  CsdmsdpZ(I6G3,i1)*DBLEK(B0i(bb1,p2,MZ2,MSd2(I6G3)))-A0(MW2)*
     &  CsdsuW(i2,I6G3)*DCONJG(CsdsuW(i1,I6G3))-3*p2*CsdsuW(i2,I6G3)*
     &  DBLEK(B0i(bb0,p2,MW2,MSu2(I6G3)))*DCONJG(CsdsuW(i1,I6G3))-2*
     &  p2*CsdsuW(i2,I6G3)*DBLEK(B0i(bb1,p2,MW2,MSu2(I6G3)))*
     &  DCONJG(CsdsuW(i1,I6G3))-CsdmsdpZ(i2,I6G3)*CsdmsdpZ(I6G3,i1)*
     &  DBLEK(B0i(bb0,p2,MZ2,MSd2(I6G3)))*MSd2(I6G3)-CsdsuW(i2,I6G3)*
     &  DBLEK(B0i(bb0,p2,MW2,MSu2(I6G3)))*DCONJG(CsdsuW(i1,I6G3))*
     &  MSu2(I6G3))
    	enddo

    	do I2G3 = 1,2
    	do I6G3 = 1,6
       self=self-(CHmSupSdp(I6G3,i1,I2G3)*CHpSumSdm(i2,I6G3,I2G3)*
     &  DBLEK(B0i(bb0,p2,MassHpm2(I2G3),MSu2(I6G3))))
    	enddo
    	enddo

    	do I6G3 = 1,6
    	do I6G4 = 1,6
       self=self-(ChSdmSdp(i2,I6G4,I6G3)*ChSdmSdp(I6G4,i1,I6G3)*
     &  DBLEK(B0i(bb0,p2,Masshh2(I6G3),MSd2(I6G4))))
    	enddo
    	enddo
       elseif(iew.eq.2)then
       self=(-4*g3**2*IndexDelta*(2*p2*
     &  DBLEK(B0i(bb1,p2,0D0,MSd2(i1)))+DBLEK(B0i(bb0,p2,0D0,MSd2(i1)))*
     &  (3*p2+MSd2(i1))))/3.

    	do I3G3 = 1,3
       self=self+(-8*g3**2*(A0(MGL2)*(CF15dsdL(I3G3,i1)*
     &  DCONJG(CF15dsdL(I3G3,i2))+CF15dsdR(I3G3,i1)*
     &  DCONJG(CF15dsdR(I3G3,i2)))+CF15dsdL(I3G3,i1)*(p2*
     &  DBLEK(B0i(bb1,p2,MFd2(I3G3),MGL2))*DCONJG(CF15dsdL(I3G3,i2))+
     &  DBLEK(B0i(bb0,p2,MGL2,MFd2(I3G3)))*(-(DCONJG(CF15dsdR(I3G3,i2)
     &  )*MassFd(I3G3)*MGL)+DCONJG(CF15dsdL(I3G3,i2))*
     &  MFd2(I3G3)))+CF15dsdR(I3G3,i1)*(p2*DBLEK(B0i(bb1,p2,MFd2(I3G3)
     &  ,MGL2))*DCONJG(CF15dsdR(I3G3,i2))+
     &  DBLEK(B0i(bb0,p2,MGL2,MFd2(I3G3)))*(-(DCONJG(CF15dsdL(I3G3,i2)
     &  )*MassFd(I3G3)*MGL)+DCONJG(CF15dsdR(I3G3,i2))*
     &  MFd2(I3G3)))))/3.
    	enddo

    	do I6G3 = 1,6
       self=self+(-(g3**2*A0(MSd2(I6G3))*(+
     &  CSd4p1QCD(i2,I6G3,i1,I6G3)+3*
     &  CSd4p2QCD(i2,I6G3,i1,I6G3)))-g3**2*A0(MSu2(I6G3))*(3*
     &  CSu2Sd2p1QCD(I6G3,I6G3,i2,i1)+CSu2Sd2p2QCD(I6G3,I6G3,i2,i1)))
    	enddo
       endif

       self=self*fac
       end Subroutine SelfSbottom

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Subroutine SelfSbottomN(P2,i1,i2,self,iew,iuv)
      implicit none
#include "looptools.h"  
      integer i,igen,gt1,gt2,gt3,gt4,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3,I3G5,i1,i2,IndexDelta,
     &          iew,iuv

      double precision Q,P2,MGL,MGL2,divergence
        
      double precision absM3, phiM3
      common /gluino/ absM3,phiM3


      double precision Qs

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3   
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      common /scale/ Qs      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3

      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv


      double complex IC,self,x,DBLEN
#include "HdecayTCLs.inc"
       DBLEN(x)=x

       if(iuv.eq.1)then
         self=0
         return
       endif
       MGL=absM3;MGL2=MGL**2
        IC=(0,1D0)
       if (i1.eq.i2) then
        IndexDelta=1
       else 
        IndexDelta=0
       endif

       self=0D0

       if(iew.eq.1)then
       self=(36*A0(MW2)*CSdSdWW(i2,i1)+18*A0(MZ2)*CSdSdZZ(i2,i1)
     &  -IndexDelta* e**2*(2*p2*DBLEN(B0i(bb1,p2,0D0,MSd2(i1)))+
     &  DBLEN(B0i(bb0,p2,0D0,MSd2(i1)))*(3*p2+MSd2(i1))))/9.

    	do I2G3 = 1,2
       self=self+IC*A0(MassHpm2(I2G3))*CHmHpSdmSdp(i2,I2G3,i1,I2G3)
    	enddo

    	do I3G3 = 1,3
       self=self-(A0(MSv2(I3G3))*CSd2Sv2(i2,i1,I3G3))
    	enddo

    	do I2G3 = 1,2
    	do I3G3 = 1,3
       self=self-2*(A0(MCha2(I2G3))*(cupchapsdL(I2G3,I3G3,i1)*
     &  DCONJG(cupchapsdL(I2G3,I3G3,i2))+cupchapsdR(I2G3,I3G3,i1)*
     &  DCONJG(cupchapsdR(I2G3,I3G3,i2)))+cupchapsdL(I2G3,I3G3,i1)*(-
     &  (p2*DBLEN(B0i(bb1,p2,MCha2(I2G3),MFu2(I3G3)))*
     &  DCONJG(cupchapsdL(I2G3,I3G3,i2)))+DBLEN(B0i(bb0,p2,MCha2(I2G3)
     &  ,MFu2(I3G3)))*(DCONJG(cupchapsdR(I2G3,I3G3,i2))*MassFu(I3G3)*
     &  MCha(I2G3)+DCONJG(cupchapsdL(I2G3,I3G3,i2))*(-p2+MFu2(I3G3))))+
     &  cupchapsdR(I2G3,I3G3,i1)*(-(p2*DBLEN(B0i(bb1,p2,MCha2(I2G3)
     &  ,MFu2(I3G3)))*DCONJG(cupchapsdR(I2G3,I3G3,i2)))+
     &  DBLEN(B0i(bb0,p2,MCha2(I2G3),MFu2(I3G3)))*
     &  (DCONJG(cupchapsdL(I2G3,I3G3,i2))*MassFu(I3G3)*sqrt(MCha2(I2G3))+
     &  DCONJG(cupchapsdR(I2G3,I3G3,i2))*(-p2+MFu2(I3G3)))))
    	enddo
    	enddo


    	do I3G3 = 1,3
    	do I5G3 = 1,5
       self=self-2*(A0(MNeu2(I5G3))*(cchidmsdpL(I5G3,I3G3,i1)*
     &  DCONJG(cchidmsdpL(I5G3,I3G3,i2))+cchidmsdpR(I5G3,I3G3,i1)*
     &  DCONJG(cchidmsdpR(I5G3,I3G3,i2)))+cchidmsdpR(I5G3,I3G3,i1)*(-
     &  (p2*DBLEN(B0i(bb1,p2,MNeu2(I5G3),MFd2(I3G3)))*
     &  DCONJG(cchidmsdpR(I5G3,I3G3,i2)))+DBLEN(B0i(bb0,p2,MFd2(I3G3)
     &  ,MNeu2(I5G3)))*(DCONJG(cchidmsdpR(I5G3,I3G3,i2))*(-p2+
     &  MFd2(I3G3))+DCONJG(cchidmsdpL(I5G3,I3G3,i2))*MassFd(I3G3)*
     &  MNeu(I5G3)))+cchidmsdpL(I5G3,I3G3,i1)*(-(p2*
     &  DBLEN(B0i(bb1,p2,MNeu2(I5G3),MFd2(I3G3)))*
     &  DCONJG(cchidmsdpL(I5G3,I3G3,i2)))+DBLEN(B0i(bb0,p2,MFd2(I3G3)
     &  ,MNeu2(I5G3)))*(DCONJG(cchidmsdpL(I5G3,I3G3,i2))*(-p2+
     &  MFd2(I3G3))+DCONJG(cchidmsdpR(I5G3,I3G3,i2))*MassFd(I3G3)*MNeu(I5G3))))
    	enddo
    	enddo

c        print*,  'without sfermion', self*fac
c           self=0D0
    	do I6G3 = 1,6
       self=self+((IC*A0(Masshh2(I6G3))*ChhSdmSdp(i2,I6G3,i1,I6G3))
     &  /2.-A0(MSe2(I6G3))*CSd2Se2(i2,i1,I6G3,I6G3)-A0(MSd2(I6G3))*
     &  CSd4p1(i2,I6G3,i1,I6G3)-3*A0(MSd2(I6G3))*
     &  CSd4p2(i2,I6G3,i1,I6G3)-A0(MZ2)*CsdmsdpZ(i2,I6G3)*
     &  CsdmsdpZ(I6G3,i1)-3*A0(MSu2(I6G3))*CSu2Sd2p1(I6G3,I6G3,i2,i1)-
     &  A0(MSu2(I6G3))*CSu2Sd2p2(I6G3,I6G3,i2,i1)-3*p2*
     &  CsdmsdpZ(i2,I6G3)*CsdmsdpZ(I6G3,i1)*
     &  DBLEN(B0i(bb0,p2,MZ2,MSd2(I6G3)))-2*p2*CsdmsdpZ(i2,I6G3)*
     &  CsdmsdpZ(I6G3,i1)*DBLEN(B0i(bb1,p2,MZ2,MSd2(I6G3)))-A0(MW2)*
     &  CsdsuW(i2,I6G3)*DCONJG(CsdsuW(i1,I6G3))-3*p2*CsdsuW(i2,I6G3)*
     &  DBLEN(B0i(bb0,p2,MW2,MSu2(I6G3)))*DCONJG(CsdsuW(i1,I6G3))-2*
     &  p2*CsdsuW(i2,I6G3)*DBLEN(B0i(bb1,p2,MW2,MSu2(I6G3)))*
     &  DCONJG(CsdsuW(i1,I6G3))-CsdmsdpZ(i2,I6G3)*CsdmsdpZ(I6G3,i1)*
     &  DBLEN(B0i(bb0,p2,MZ2,MSd2(I6G3)))*MSd2(I6G3)-CsdsuW(i2,I6G3)*
     &  DBLEN(B0i(bb0,p2,MW2,MSu2(I6G3)))*DCONJG(CsdsuW(i1,I6G3))*
     &  MSu2(I6G3))
    	enddo
    	do I2G3 = 1,2
    	do I6G3 = 1,6
       self=self-(CHmSupSdp(I6G3,i1,I2G3)*CHpSumSdm(i2,I6G3,I2G3)*
     &  DBLEN(B0i(bb0,p2,MassHpm2(I2G3),MSu2(I6G3))))
    	enddo
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       self=self-(ChSdmSdp(i2,I6G4,I6G3)*ChSdmSdp(I6G4,i1,I6G3)*
     &  DBLEN(B0i(bb0,p2,Masshh2(I6G3),MSd2(I6G4))))
    	enddo
    	enddo

       elseif(iew.eq.2)then
       self=(-4*g3**2*IndexDelta*(2*p2*
     &  DBLEN(B0i(bb1,p2,0D0,MSd2(i1)))+DBLEN(B0i(bb0,p2,0D0,MSd2(i1)))*
     &  (3*p2+MSd2(i1))))/3.

    	do I3G3 = 1,3
       self=self+(-8*g3**2*(A0(MGL2)*(CF15dsdL(I3G3,i1)*
     &  DCONJG(CF15dsdL(I3G3,i2))+CF15dsdR(I3G3,i1)*
     &  DCONJG(CF15dsdR(I3G3,i2)))+CF15dsdL(I3G3,i1)*(p2*
     &  DBLEN(B0i(bb1,p2,MFd2(I3G3),MGL2))*DCONJG(CF15dsdL(I3G3,i2))+
     &  DBLEN(B0i(bb0,p2,MGL2,MFd2(I3G3)))*(-(DCONJG(CF15dsdR(I3G3,i2)
     &  )*MassFd(I3G3)*MGL)+DCONJG(CF15dsdL(I3G3,i2))*
     &  MFd2(I3G3)))+CF15dsdR(I3G3,i1)*(p2*DBLEN(B0i(bb1,p2,MFd2(I3G3)
     &  ,MGL2))*DCONJG(CF15dsdR(I3G3,i2))+
     &  DBLEN(B0i(bb0,p2,MGL2,MFd2(I3G3)))*(-(DCONJG(CF15dsdL(I3G3,i2)
     &  )*MassFd(I3G3)*MGL)+DCONJG(CF15dsdR(I3G3,i2))*
     &  MFd2(I3G3)))))/3.
    	enddo

    	do I6G3 = 1,6
       self=self+(-(g3**2*A0(MSd2(I6G3))*(+
     &  CSd4p1QCD(i2,I6G3,i1,I6G3)+3*
     &  CSd4p2QCD(i2,I6G3,i1,I6G3)))-g3**2*A0(MSu2(I6G3))*(3*
     &  CSu2Sd2p1QCD(I6G3,I6G3,i2,i1)+CSu2Sd2p2QCD(I6G3,I6G3,i2,i1)))
    	enddo
       endif

      self=self*fac
      end Subroutine SelfSbottomN

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Subroutine DSelfSbottom(P2,i1,i2,Dself,iew,iuv)
      implicit none
#include "looptools.h"  
      integer i,igen,gt1,gt2,gt3,gt4,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3,I3G5,i1,i2,IndexDelta,
     &          iew,iuv

      double precision Q,P2,MGL,MGL2,divergence
      double precision absM3, phiM3
      common /gluino/ absM3,phiM3

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      double complex IC,Dself
#include "HdecayTCLs.inc"
      if (iuv.eq.1)then
        Dself=0D0
        return
      endif

        IC=(0,1D0)
        MGL=absM3;MGL2=MGL**2
       if (i1.eq.i2) then
        IndexDelta=1
       else 
        IndexDelta=0
       endif
       DSELF=0D0

       if(iew.eq.1)then
c We haved changed msd(i)^2 to P2

c       Dself=Dself-(e**2*IndexDelta*(3*DBLEK(B0i(bb0,p2,0D0,MSd2(i1))
c     &  )+2*DBLEK(B0i(bb1,p2,0D0,MSd2(i1)))+3*p2*
c     &  DBLEK(B0i(dbb0,p2,0D0,MSd2(i1)))+2*p2*
c     &  DBLEK(B0i(dbb1,p2,0D0,MSd2(i1)))+
c     &  DBLEK(B0i(dbb0,p2,0D0,MSd2(i1)))*MSd2(i1)))/9.

       Dself=Dself-(e**2*IndexDelta*(3*DBLEK(B0i(bb0,p2,0D0,P2)
     &  )+2*DBLEK(B0i(bb1,p2,0D0,P2))+3*p2*
     &  DBLEK(B0i(dbb0,p2,0D0,P2))+2*p2*
     &  DBLEK(B0i(dbb1,p2,0D0,P2))+
     &  DBLEK(B0i(dbb0,p2,0D0,P2))*P2))/9.


    	do I2G3 = 1,2
    	do I3G3 = 1,3
       Dself=Dself+2*(cupchapsdL(I2G3,I3G3,i1)*
     &  (DBLEK(B0i(bb0,p2,MCha2(I2G3),MFu2(I3G3)))*
     &  DCONJG(cupchapsdL(I2G3,I3G3,i2))+DBLEK(B0i(bb1,p2,MCha2(I2G3)
     &  ,MFu2(I3G3)))*DCONJG(cupchapsdL(I2G3,I3G3,i2))+p2*
     &  DBLEK(B0i(dbb0,p2,MCha2(I2G3),MFu2(I3G3)))*
     &  DCONJG(cupchapsdL(I2G3,I3G3,i2))+p2*
     &  DBLEK(B0i(dbb1,p2,MCha2(I2G3),MFu2(I3G3)))*
     &  DCONJG(cupchapsdL(I2G3,I3G3,i2))-DBLEK(B0i(dbb0,p2,MCha2(I2G3)
     &  ,MFu2(I3G3)))*DCONJG(cupchapsdR(I2G3,I3G3,i2))*MassFu(I3G3)*
     &  MCha(I2G3)-DBLEK(B0i(dbb0,p2,MCha2(I2G3),MFu2(I3G3)))*
     &  DCONJG(cupchapsdL(I2G3,I3G3,i2))*MFu2(I3G3))+
     &  cupchapsdR(I2G3,I3G3,i1)*(DBLEK(B0i(bb0,p2,MCha2(I2G3)
     &  ,MFu2(I3G3)))*DCONJG(cupchapsdR(I2G3,I3G3,i2))+
     &  DBLEK(B0i(bb1,p2,MCha2(I2G3),MFu2(I3G3)))*
     &  DCONJG(cupchapsdR(I2G3,I3G3,i2))+p2*
     &  DBLEK(B0i(dbb0,p2,MCha2(I2G3),MFu2(I3G3)))*
     &  DCONJG(cupchapsdR(I2G3,I3G3,i2))+p2*
     &  DBLEK(B0i(dbb1,p2,MCha2(I2G3),MFu2(I3G3)))*
     &  DCONJG(cupchapsdR(I2G3,I3G3,i2))-DBLEK(B0i(dbb0,p2,MCha2(I2G3)
     &  ,MFu2(I3G3)))*DCONJG(cupchapsdL(I2G3,I3G3,i2))*MassFu(I3G3)*
     &  MCha(I2G3)-DBLEK(B0i(dbb0,p2,MCha2(I2G3),MFu2(I3G3)))*
     &  DCONJG(cupchapsdR(I2G3,I3G3,i2))*MFu2(I3G3)))
    	enddo
    	enddo
    	do I3G3 = 1,3
    	do I5G3 = 1,5
       Dself=Dself+2*(cchidmsdpR(I5G3,I3G3,i1)*
     &  (DBLEK(B0i(bb0,p2,MFd2(I3G3),MNeu2(I5G3)))*
     &  DCONJG(cchidmsdpR(I5G3,I3G3,i2))+DBLEK(B0i(bb1,p2,MNeu2(I5G3)
     &  ,MFd2(I3G3)))*DCONJG(cchidmsdpR(I5G3,I3G3,i2))+p2*
     &  DBLEK(B0i(dbb0,p2,MFd2(I3G3),MNeu2(I5G3)))*
     &  DCONJG(cchidmsdpR(I5G3,I3G3,i2))+p2*
     &  DBLEK(B0i(dbb1,p2,MNeu2(I5G3),MFd2(I3G3)))*
     &  DCONJG(cchidmsdpR(I5G3,I3G3,i2))-DBLEK(B0i(dbb0,p2,MFd2(I3G3)
     &  ,MNeu2(I5G3)))*DCONJG(cchidmsdpR(I5G3,I3G3,i2))*MFd2(I3G3)-
     &  DBLEK(B0i(dbb0,p2,MFd2(I3G3),MNeu2(I5G3)))*
     &  DCONJG(cchidmsdpL(I5G3,I3G3,i2))*MassFd(I3G3)*MNeu(I5G3))+
     &  cchidmsdpL(I5G3,I3G3,i1)*(DBLEK(B0i(bb0,p2,MFd2(I3G3)
     &  ,MNeu2(I5G3)))*DCONJG(cchidmsdpL(I5G3,I3G3,i2))+
     &  DBLEK(B0i(bb1,p2,MNeu2(I5G3),MFd2(I3G3)))*
     &  DCONJG(cchidmsdpL(I5G3,I3G3,i2))+p2*
     &  DBLEK(B0i(dbb0,p2,MFd2(I3G3),MNeu2(I5G3)))*
     &  DCONJG(cchidmsdpL(I5G3,I3G3,i2))+p2*
     &  DBLEK(B0i(dbb1,p2,MNeu2(I5G3),MFd2(I3G3)))*
     &  DCONJG(cchidmsdpL(I5G3,I3G3,i2))-DBLEK(B0i(dbb0,p2,MFd2(I3G3)
     &  ,MNeu2(I5G3)))*DCONJG(cchidmsdpL(I5G3,I3G3,i2))*MFd2(I3G3)-
     &  DBLEK(B0i(dbb0,p2,MFd2(I3G3),MNeu2(I5G3)))*
     &  DCONJG(cchidmsdpR(I5G3,I3G3,i2))*MassFd(I3G3)*MNeu(I5G3)))
    	enddo
    	enddo
    	do I6G3 = 1,6
       Dself=Dself+(-(CsdmsdpZ(i2,I6G3)*CsdmsdpZ(I6G3,i1)*(3*
     &  DBLEK(B0i(bb0,p2,MZ2,MSd2(I6G3)))+2*
     &  DBLEK(B0i(bb1,p2,MZ2,MSd2(I6G3)))+3*p2*
     &  DBLEK(B0i(dbb0,p2,MZ2,MSd2(I6G3)))+2*p2*
     &  DBLEK(B0i(dbb1,p2,MZ2,MSd2(I6G3)))+
     &  DBLEK(B0i(dbb0,p2,MZ2,MSd2(I6G3)))*MSd2(I6G3)))-
     &  CsdsuW(i2,I6G3)*DCONJG(CsdsuW(i1,I6G3))*(3*
     &  DBLEK(B0i(bb0,p2,MW2,MSu2(I6G3)))+2*
     &  DBLEK(B0i(bb1,p2,MW2,MSu2(I6G3)))+3*p2*
     &  DBLEK(B0i(dbb0,p2,MW2,MSu2(I6G3)))+2*p2*
     &  DBLEK(B0i(dbb1,p2,MW2,MSu2(I6G3)))+
     &  DBLEK(B0i(dbb0,p2,MW2,MSu2(I6G3)))*MSu2(I6G3)))
    	enddo
    	do I2G3 = 1,2
    	do I6G3 = 1,6
       Dself=Dself-(CHmSupSdp(I6G3,i1,I2G3)*CHpSumSdm(i2,I6G3,I2G3)*
     &  DBLEK(B0i(dbb0,p2,MassHpm2(I2G3),MSu2(I6G3))))
    	enddo
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       Dself=Dself-(ChSdmSdp(i2,I6G4,I6G3)*ChSdmSdp(I6G4,i1,I6G3)*
     &  DBLEK(B0i(dbb0,p2,Masshh2(I6G3),MSd2(I6G4))))
    	enddo
    	enddo
       elseif(iew.eq.2)then
c We haved changed msd(i1)^2 to P2
       Dself=Dself+(-4*g3**2*IndexDelta*(3*
     &  DBLEK(B0i(bb0,p2,0D0,P2))+2*DBLEK(B0i(bb1,p2,0D0,P2))
     &  +3*p2*DBLEK(B0i(dbb0,p2,0D0,P2))+2*p2*
     &  DBLEK(B0i(dbb1,p2,0D0,P2))+DBLEK(B0i(dbb0,p2,0D0,P2))
     &  *P2))/3.


    	do I3G3 = 1,3
       Dself=Dself+(-8*g3**2*(CF15dsdL(I3G3,i1)*
     &  (DBLEK(B0i(bb1,p2,MFd2(I3G3),MGL2))*DCONJG(CF15dsdL(I3G3,i2))+
     &  p2*DBLEK(B0i(dbb1,p2,MFd2(I3G3),MGL2))*
     &  DCONJG(CF15dsdL(I3G3,i2))+DBLEK(B0i(dbb0,p2,MGL2,MFd2(I3G3)))*
     &  (-(DCONJG(CF15dsdR(I3G3,i2))*MassFd(I3G3)*MGL)+
     &  DCONJG(CF15dsdL(I3G3,i2))*MFd2(I3G3)))+CF15dsdR(I3G3,i1)*
     &  (DBLEK(B0i(bb1,p2,MFd2(I3G3),MGL2))*DCONJG(CF15dsdR(I3G3,i2))+
     &  p2*DBLEK(B0i(dbb1,p2,MFd2(I3G3),MGL2))*
     &  DCONJG(CF15dsdR(I3G3,i2))+DBLEK(B0i(dbb0,p2,MGL2,MFd2(I3G3)))*
     &  (-(DCONJG(CF15dsdL(I3G3,i2))*MassFd(I3G3)*MGL)+
     &  DCONJG(CF15dsdR(I3G3,i2))*MFd2(I3G3)))))/3.
    	enddo
       endif
       Dself=Dself*fac
       end Subroutine DSelfSbottom
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      double complex function SelfHZ(P2,i)
      implicit none
#include "looptools.h"  
      integer i,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3

      double precision P2

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)     
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)

      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv

      double precision ZH5(5,5),ZH(6,6)    
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)

      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU

       double complex IC,CTerm
#include "HdecayTCLs.inc"
#include "HdecayCTs.inc"
        IC=(0,1D0)
       selfHZ=0D0

       selfHZ=selfHZ+CWWZ*IC*(3*B0i(bb0,P2,MW2,MW2)*ChWmWp(i)+
     &  B0i(bb1,P2,MW2,MW2)*(ChU3U3(i)-ChU4U4(i)+6*ChWmWp(i)))

    	do I2G3 = 1,2
       selfHZ=selfHZ-(IC*(CHpHmZ*B0i(bb0,P2,MassHpm2(I2G3)
     &  ,MassHpm2(I2G3))*ChHmHp(I2G3,I2G3,i)+2*CHpHmZ*
     &  B0i(bb1,P2,MassHpm2(I2G3),MassHpm2(I2G3))*ChHmHp(I2G3,I2G3,i)+
     &  (2*B0i(bb0,P2,MW2,MassHpm2(I2G3))+
     &  B0i(bb1,P2,MW2,MassHpm2(I2G3)))*(ChHmWp(I2G3,i)-ChHpWm(i,I2G3)
     &  )*CHmWpZ(I2G3)))
    	enddo

    	do I2G3 = 1,2
    	do I2G4 = 1,2
       selfHZ=selfHZ+2*IC*(B0i(bb0,P2,MCha2(I2G3),MCha2(I2G4))*
     &  (CF12ZR(I2G3,I2G4)*CLhChapCham(I2G4,I2G3,i)+CF12ZL(I2G3,I2G4)*
     &  CRhChapCham(I2G4,I2G3,i))*MCha(I2G3)+B0i(bb1,P2,MCha2(I2G3)
     &  ,MCha2(I2G4))*(CF12ZL(I2G3,I2G4)*(CRhChapCham(I2G4,I2G3,i)*
     &  MCha(I2G3)+CLhChapCham(I2G4,I2G3,i)*MCha(I2G4))+
     &  CF12ZR(I2G3,I2G4)*(CLhChapCham(I2G4,I2G3,i)*MCha(I2G3)+
     &  CRhChapCham(I2G4,I2G3,i)*MCha(I2G4))))
    	enddo
    	enddo
    	do I3G3 = 1,3
       selfHZ=selfHZ+IC*(-(CsvsvZ*B0i(bb0,P2,MSv2(I3G3),MSv2(I3G3))*
     &  ChSvSvconj(i))-2*CsvsvZ*B0i(bb1,P2,MSv2(I3G3),MSv2(I3G3))*
     &  ChSvSvconj(i)+6*(CddZL+CddZR)*B0i(bb1,P2,MFd2(I3G3),MFd2(I3G3)
     &  )*(CLhFdpFdm(I3G3,I3G3,i)+CRhFdpFdm(I3G3,I3G3,i))*MassFd(I3G3)+
     &  6*B0i(bb0,P2,MFd2(I3G3),MFd2(I3G3))*(CddZR*
     &  CLhFdpFdm(I3G3,I3G3,i)+CddZL*CRhFdpFdm(I3G3,I3G3,i))*
     &  MassFd(I3G3)+2*(ctautauZL+ctautauZR)*B0i(bb1,P2,MFe2(I3G3)
     &  ,MFe2(I3G3))*(CLhFepFem(I3G3,I3G3,i)+CRhFepFem(I3G3,I3G3,i))*
     &  MassFe(I3G3)+2*B0i(bb0,P2,MFe2(I3G3),MFe2(I3G3))*(ctautauZR*
     &  CLhFepFem(I3G3,I3G3,i)+ctautauZL*CRhFepFem(I3G3,I3G3,i))*
     &  MassFe(I3G3)+6*(CuuZL+CuuZR)*B0i(bb1,P2,MFu2(I3G3),MFu2(I3G3))
     &  *(CLhFumFup(I3G3,I3G3,i)+CRhFumFup(I3G3,I3G3,i))*MassFu(I3G3)+
     &  6*B0i(bb0,P2,MFu2(I3G3),MFu2(I3G3))*(CuuZR*
     &  CLhFumFup(I3G3,I3G3,i)+CuuZL*CRhFumFup(I3G3,I3G3,i))*MassFu(I3G3))
    	enddo

    	do I5G3 = 1,5
    	do I5G4 = 1,5
       selfHZ=selfHZ+IC*(B0i(bb0,P2,MNeu2(I5G3),MNeu2(I5G4))*
     &  (CF11ZR(I5G3,I5G4)*CLhChiChi(I5G4,I5G3,i)+CF11ZL(I5G3,I5G4)*
     &  CRhChiChi(I5G4,I5G3,i))*MNeu(I5G3)+B0i(bb1,P2,MNeu2(I5G3)
     &  ,MNeu2(I5G4))*(CF11ZL(I5G3,I5G4)*(CRhChiChi(I5G4,I5G3,i)*
     &  MNeu(I5G3)+CLhChiChi(I5G4,I5G3,i)*MNeu(I5G4))+CF11ZR(I5G3,I5G4)
     &  *(CLhChiChi(I5G4,I5G3,i)*MNeu(I5G3)+CRhChiChi(I5G4,I5G3,i)*
     &  MNeu(I5G4))))
    	enddo
    	enddo
   
    	do I6G3 = 1,6
       selfHZ=selfHZ+(2*MZ2*B0i(bb0,P2,MZ2,Masshh2(I6G3))+
     &  B0i(bb1,P2,MZ2,Masshh2(I6G3))*(P2+MZ2-P2))/MZ2
     &  *ChhZ(i,I6G3)*ChZZ(I6G3)
    	enddo

    	do I6G3 = 1,6
    	do I6G4 = 1,6
       selfHZ=selfHZ+((B0i(bb0,P2,Masshh2(I6G3),Masshh2(I6G4))*
     &  Chhh(i,I6G3,I6G4)*ChhZ(I6G3,I6G4))/2.+B0i(bb1,P2,Masshh2(I6G3)
     &  ,Masshh2(I6G4))*Chhh(i,I6G3,I6G4)*ChhZ(I6G3,I6G4)-IC*(3*
     &  B0i(bb0,P2,MSd2(I6G3),MSd2(I6G4))*ChSdmSdp(I6G3,I6G4,i)*
     &  CsdmsdpZ(I6G4,I6G3)+6*B0i(bb1,P2,MSd2(I6G3),MSd2(I6G4))*
     &  ChSdmSdp(I6G3,I6G4,i)*CsdmsdpZ(I6G4,I6G3)+
     &  B0i(bb0,P2,MSe2(I6G3),MSe2(I6G4))*ChSemSep(I6G3,I6G4,i)*
     &  CsemsepZ(I6G4,I6G3)+2*B0i(bb1,P2,MSe2(I6G3),MSe2(I6G4))*
     &  ChSemSep(I6G3,I6G4,i)*CsemsepZ(I6G4,I6G3)+3*
     &  B0i(bb0,P2,MSu2(I6G3),MSu2(I6G4))*ChSupSum(I6G3,I6G4,i)*
     &  CsupsumZ(I6G4,I6G3)+6*B0i(bb1,P2,MSu2(I6G3),MSu2(I6G4))*
     &  ChSupSum(I6G3,I6G4,i)*CsupsumZ(I6G4,I6G3)))
    	enddo
    	enddo

       CTerm=IC*MZ*(1D0/2D0*dZNhiggs(1,i)+(-dCosB1*SB+CB*dSinB1)*ZH(i,2))
       selfHZ=selfHZ*fac  + CTerm    

       
      end function SelfHZ
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      double complex function SelfHH(P2,i,j)
      implicit none
#include "looptools.h"  
      integer i,j,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3

      double precision P2

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)     
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
    
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv

       double complex IC
#include "HdecayTCLs.inc"

        IC=(0,1D0)

       selfHH=0D0
       selfHH=selfHH+(-4*IC*A0(MW2)*ChhWmWp(i,j)-2*IC*A0(MZ2)*
     &  ChhZZ(i,j)+B0i(bb0,P2,MZ2,MZ2)*ChU2U2(i)*ChU2U2(j)+
     &  B0i(bb0,P2,MW2,MW2)*ChU3U3(i)*ChU3U3(j)+B0i(bb0,P2,MW2,MW2)*
     &  ChU4U4(i)*ChU4U4(j)-4*B0i(bb0,P2,MW2,MW2)*ChWmWp(i)*ChWmWp(j)-
     &  2*B0i(bb0,P2,MZ2,MZ2)*ChZZ(i)*ChZZ(j))
    	do I2G3 = 1,2
       selfHH=selfHH+(IC*A0(MassHpm2(I2G3))*ChhHmHp(I2G3,i,I2G3,j)+
     &  (ChHmWp(I2G3,j)*ChHpWm(i,I2G3)+ChHmWp(I2G3,i)*ChHpWm(j,I2G3))*
     &  (A0(MW2)+2*P2*B0i(bb1,P2,MW2,MassHpm2(I2G3))+
     &  B0i(bb0,P2,MW2,MassHpm2(I2G3))*(3*P2+MassHpm2(I2G3))))
    	enddo
    	do I2G3 = 1,2
    	do I2G4 = 1,2
       selfHH=selfHH+(-(B0i(bb0,P2,MassHpm2(I2G3),MassHpm2(I2G4))*
     &  ChHmHp(I2G3,I2G4,i)*ChHmHp(I2G4,I2G3,j))+2*(A0(MCha2(I2G4))*
     &  (CLhChapCham(I2G4,I2G3,i)*CRhChapCham(I2G3,I2G4,j)+
     &  CLhChapCham(I2G3,I2G4,j)*CRhChapCham(I2G4,I2G3,i))+P2*
     &  B0i(bb1,P2,MCha2(I2G3),MCha2(I2G4))*(CLhChapCham(I2G4,I2G3,i)*
     &  CRhChapCham(I2G3,I2G4,j)+CLhChapCham(I2G3,I2G4,j)*
     &  CRhChapCham(I2G4,I2G3,i))+B0i(bb0,P2,MCha2(I2G3),MCha2(I2G4))*
     &  (CRhChapCham(I2G3,I2G4,j)*(CRhChapCham(I2G4,I2G3,i)*MCha(I2G3)*
     &  MCha(I2G4)+CLhChapCham(I2G4,I2G3,i)*MCha2(I2G3))+
     &  CLhChapCham(I2G3,I2G4,j)*(CLhChapCham(I2G4,I2G3,i)*MCha(I2G3)*
     &  MCha(I2G4)+CRhChapCham(I2G4,I2G3,i)*MCha2(I2G3)))))
    	enddo
    	enddo
    	do I3G3 = 1,3
       selfHH=selfHH+(IC*A0(MSv2(I3G3))*ChhSvSvconj(i,j)-
     &  B0i(bb0,P2,MSv2(I3G3),MSv2(I3G3))*ChSvSvconj(i)*ChSvSvconj(j)+
     &  6*A0(MFd2(I3G3))*(CLhFdpFdm(I3G3,I3G3,j)*
     &  CRhFdpFdm(I3G3,I3G3,i)+CLhFdpFdm(I3G3,I3G3,i)*
     &  CRhFdpFdm(I3G3,I3G3,j))+6*P2*B0i(bb1,P2,MFd2(I3G3),MFd2(I3G3))
     &  *(CLhFdpFdm(I3G3,I3G3,j)*CRhFdpFdm(I3G3,I3G3,i)+
     &  CLhFdpFdm(I3G3,I3G3,i)*CRhFdpFdm(I3G3,I3G3,j))+2*A0(MFe2(I3G3)
     &  )*(CLhFepFem(I3G3,I3G3,j)*CRhFepFem(I3G3,I3G3,i)+
     &  CLhFepFem(I3G3,I3G3,i)*CRhFepFem(I3G3,I3G3,j))+2*P2*
     &  B0i(bb1,P2,MFe2(I3G3),MFe2(I3G3))*(CLhFepFem(I3G3,I3G3,j)*
     &  CRhFepFem(I3G3,I3G3,i)+CLhFepFem(I3G3,I3G3,i)*
     &  CRhFepFem(I3G3,I3G3,j))+6*A0(MFu2(I3G3))*
     &  (CLhFumFup(I3G3,I3G3,j)*CRhFumFup(I3G3,I3G3,i)+
     &  CLhFumFup(I3G3,I3G3,i)*CRhFumFup(I3G3,I3G3,j))+6*P2*
     &  B0i(bb1,P2,MFu2(I3G3),MFu2(I3G3))*(CLhFumFup(I3G3,I3G3,j)*
     &  CRhFumFup(I3G3,I3G3,i)+CLhFumFup(I3G3,I3G3,i)*
     &  CRhFumFup(I3G3,I3G3,j))+6*B0i(bb0,P2,MFd2(I3G3),MFd2(I3G3))*
     &  (CLhFdpFdm(I3G3,I3G3,i)+CRhFdpFdm(I3G3,I3G3,i))*
     &  (CLhFdpFdm(I3G3,I3G3,j)+CRhFdpFdm(I3G3,I3G3,j))*MFd2(I3G3)+2*
     &  B0i(bb0,P2,MFe2(I3G3),MFe2(I3G3))*(CLhFepFem(I3G3,I3G3,i)+
     &  CRhFepFem(I3G3,I3G3,i))*(CLhFepFem(I3G3,I3G3,j)+
     &  CRhFepFem(I3G3,I3G3,j))*MFe2(I3G3)+6*B0i(bb0,P2,MFu2(I3G3)
     &  ,MFu2(I3G3))*(CLhFumFup(I3G3,I3G3,i)+CRhFumFup(I3G3,I3G3,i))*
     &  (CLhFumFup(I3G3,I3G3,j)+CRhFumFup(I3G3,I3G3,j))*MFu2(I3G3))
    	enddo
    	do I5G3 = 1,5
    	do I5G4 = 1,5
       selfHH=selfHH+(A0(MNeu2(I5G4))*(CLhChiChi(I5G4,I5G3,i)*
     &  CRhChiChi(I5G3,I5G4,j)+CLhChiChi(I5G3,I5G4,j)*
     &  CRhChiChi(I5G4,I5G3,i))+P2*B0i(bb1,P2,MNeu2(I5G3),MNeu2(I5G4))
     &  *(CLhChiChi(I5G4,I5G3,i)*CRhChiChi(I5G3,I5G4,j)+
     &  CLhChiChi(I5G3,I5G4,j)*CRhChiChi(I5G4,I5G3,i))+
     &  B0i(bb0,P2,MNeu2(I5G3),MNeu2(I5G4))*(CRhChiChi(I5G3,I5G4,j)*
     &  (CRhChiChi(I5G4,I5G3,i)*MNeu(I5G3)*MNeu(I5G4)+
     &  CLhChiChi(I5G4,I5G3,i)*MNeu2(I5G3))+CLhChiChi(I5G3,I5G4,j)*
     &  (CLhChiChi(I5G4,I5G3,i)*MNeu(I5G3)*MNeu(I5G4)+
     &  CRhChiChi(I5G4,I5G3,i)*MNeu2(I5G3))))
    	enddo
    	enddo
    	do I6G3 = 1,6
       selfHH=selfHH+((IC*A0(Masshh2(I6G3))*Chhhh(i,j,I6G3,I6G3))/2.+
     &  3*IC*A0(MSd2(I6G3))*ChhSdmSdp(I6G3,i,I6G3,j)+IC*A0(MSe2(I6G3)
     &  )*ChhSemSep(I6G3,i,I6G3,j)+3*IC*A0(MSu2(I6G3))*
     &  ChhSupSum(I6G3,i,I6G3,j)-A0(MZ2)*ChhZ(i,I6G3)*ChhZ(j,I6G3)-3*
     &  P2*B0i(bb0,P2,MZ2,Masshh2(I6G3))*ChhZ(i,I6G3)*ChhZ(j,I6G3)-2*
     &  P2*B0i(bb1,P2,MZ2,Masshh2(I6G3))*ChhZ(i,I6G3)*ChhZ(j,I6G3)-
     &  B0i(bb0,P2,MZ2,Masshh2(I6G3))*ChhZ(i,I6G3)*ChhZ(j,I6G3)*
     &  Masshh2(I6G3))
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       selfHH=selfHH+(-(B0i(bb0,P2,Masshh2(I6G3),Masshh2(I6G4))*
     &  Chhh(i,I6G3,I6G4)*Chhh(j,I6G3,I6G4))/2.-3*
     &  B0i(bb0,P2,MSd2(I6G3),MSd2(I6G4))*ChSdmSdp(I6G3,I6G4,i)*
     &  ChSdmSdp(I6G4,I6G3,j)-B0i(bb0,P2,MSe2(I6G3),MSe2(I6G4))*
     &  ChSemSep(I6G3,I6G4,i)*ChSemSep(I6G4,I6G3,j)-3*
     &  B0i(bb0,P2,MSu2(I6G3),MSu2(I6G4))*ChSupSum(I6G3,I6G4,i)*
     &  ChSupSum(I6G4,I6G3,j))
    	enddo
    	enddo
        selfHH=selfHH*fac

      end function SelfHH

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      double complex function SelfCH(P2,i,j,iself)
      implicit none 
      integer i,j,iself,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3,Indexdelta

      integer bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k
      common /funcID/ bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k

      double precision P2,myA0
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)     
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
    
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      double complex IC,myB0i
#include "HdecayTCLs.inc"
        IC=(0,1D0)

       if(i.eq.j)then 
       Indexdelta=1
       else
       Indexdelta=0
       endif
       selfCH=0D0
       if(iself.eq.1)then
       selfCH=selfCH+(-3*CHpHmZ**2*IndexDelta*P2*
     &  myB0i(bb0k,P2,MZ2,MassHpm2(i))-2*e**2*IndexDelta*P2*
     &  myB0i(bb1k,P2,0D0,MassHpm2(i))-2*CHpHmZ**2*IndexDelta*P2*
     &  myB0i(bb1k,P2,MZ2,MassHpm2(i))+4*myA0(MW2)*CHmHpWW(i,j)+
     &  myB0i(bb0k,P2,MW2,MZ2)*CHmU3U1(j)*CHmU3U2(i)+myB0i(bb0k,P2,MW2,MZ2)
     &  *CHmU3U1(i)*CHmU3U2(j)+4*myB0i(bb0k,P2,0D0,MW2)*CHmWpA(i)*CHmWpA(j)
     &  +4*myB0i(bb0k,P2,MW2,MZ2)*CHmWpZ(i)*CHmWpZ(j)+myA0(MZ2)*(-(CHpHmZ*
     &  *2*IndexDelta)+2*CHpHmZZ(i,j))-CHpHmZ**2*IndexDelta*
     &  myB0i(bb0k,P2,MZ2,MassHpm2(i))*MassHpm2(i)-e**2*IndexDelta*
     &  myB0i(bb0k,P2,0D0,MassHpm2(i))*(3*P2+MassHpm2(i)))

    	do I2G3 = 1,2
       selfCH=selfCH-(myA0(MassHpm2(I2G3))*C2HmHp(i,I2G3,j,I2G3))
    	enddo

    	do I3G3 = 1,3
       selfCH=selfCH+(IC*myA0(MSv2(I3G3))*CHmHpSvSv(I3G3,i,I3G3,j))
    	enddo

    	do I3G3 = 1,3
        selfCH=selfCH+(2*(3*
     &  P2*myB0i(bb1k,P2,MFd2(I3G3),MFu2(I3G3))*Yd(I3G3)**2*ZP(i,1)*
     &  ZP(j,1)-myA0(MFe2(I3G3))*Ye(I3G3)**2*ZP(i,1)*ZP(j,1)+P2*
     &  myB0i(bb0k,P2,0D0,MFe2(I3G3))*Ye(I3G3)**2*ZP(i,1)*ZP(j,1)+P2*
     &  myB0i(bb1k,P2,MFe2(I3G3),0D0)*Ye(I3G3)**2*ZP(i,1)*ZP(j,1)+3*P2*
     &  myB0i(bb1k,P2,MFd2(I3G3),MFu2(I3G3))*Yu(I3G3)**2*ZP(i,2)*ZP(j,2)-
     &  3*myA0(MFd2(I3G3))*(Yd(I3G3)**2*ZP(i,1)*ZP(j,1)+Yu(I3G3)**2*
     &  ZP(i,2)*ZP(j,2))+3*myB0i(bb0k,P2,MFd2(I3G3),MFu2(I3G3))*((P2-
     &  MFu2(I3G3))*Yd(I3G3)**2*ZP(i,1)*ZP(j,1)+(P2-MFu2(I3G3))*
     &  Yu(I3G3)**2*ZP(i,2)*ZP(j,2)-MassFd(I3G3)*MassFu(I3G3)*Yd(I3G3)*
     &  Yu(I3G3)*(ZP(i,2)*ZP(j,1)+ZP(i,1)*ZP(j,2)))))
    	enddo

    	do I2G3 = 1,2
    	do I5G3 = 1,5
       selfCH=selfCH+2*(myA0(MCha2(I2G3))*(CLHpChiCha(I5G3,I2G3,j)*
     &  CRHmChiCha(I2G3,I5G3,i)+CLHmChiCha(I2G3,I5G3,i)*
     &  CRHpChiCha(I5G3,I2G3,j))-P2*myB0i(bb1k,P2,MCha2(I2G3),MNeu2(I5G3)
     &  )*(CLHpChiCha(I5G3,I2G3,j)*CRHmChiCha(I2G3,I5G3,i)+
     &  CLHmChiCha(I2G3,I5G3,i)*CRHpChiCha(I5G3,I2G3,j))+
     &  myB0i(bb0k,P2,MCha2(I2G3),MNeu2(I5G3))*(CRHpChiCha(I5G3,I2G3,j)*
     &  (CRHmChiCha(I2G3,I5G3,i)*MCha(I2G3)*MNeu(I5G3)+
     &  CLHmChiCha(I2G3,I5G3,i)*(-P2+MNeu2(I5G3)))+
     &  CLHpChiCha(I5G3,I2G3,j)*(CLHmChiCha(I2G3,I5G3,i)*MCha(I2G3)*
     &  MNeu(I5G3)+CRHmChiCha(I2G3,I5G3,i)*(-P2+MNeu2(I5G3)))))
    	enddo
    	enddo
    	do I6G3 = 1,6
       selfCH=selfCH+((IC*myA0(Masshh2(I6G3))*ChhHmHp(i,I6G3,j,I6G3))
     &  /2.+myA0(MW2)*ChHmWp(i,I6G3)*ChHpWm(I6G3,j)+3*P2*
     &  myB0i(bb0k,P2,MW2,Masshh2(I6G3))*ChHmWp(i,I6G3)*ChHpWm(I6G3,j)+2*
     &  P2*myB0i(bb1k,P2,MW2,Masshh2(I6G3))*ChHmWp(i,I6G3)*ChHpWm(I6G3,j)
     &  +3*IC*myA0(MSd2(I6G3))*CHmHpSdmSdp(I6G3,i,I6G3,j)+IC*
     &  myA0(MSe2(I6G3))*CHmHpSemSep(I6G3,i,I6G3,j)+3*IC*myA0(MSu2(I6G3))
     &  *CHmHpSupSum(I6G3,i,I6G3,j)+myB0i(bb0k,P2,MW2,Masshh2(I6G3))*
     &  ChHmWp(i,I6G3)*ChHpWm(I6G3,j)*Masshh2(I6G3))
    	enddo
    	do I2G3 = 1,2
    	do I6G3 = 1,6
       selfCH=selfCH-(myB0i(bb0k,P2,Masshh2(I6G3),MassHpm2(I2G3))*
     &  ChHmHp(i,I2G3,I6G3)*ChHmHp(I2G3,j,I6G3))
    	enddo
    	enddo
    	do I3G3 = 1,3
    	do I6G3 = 1,6
       selfCH=selfCH-(myB0i(bb0k,P2,MSe2(I6G3),MSv2(I3G3))*
     &  CHmSepSv(I3G3,I6G3,i)*CHpSemSv(I6G3,I3G3,j))
    	enddo
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       selfCH=selfCH-3*myB0i(bb0k,P2,MSd2(I6G4),MSu2(I6G3))*
     &  CHmSupSdp(I6G3,I6G4,i)*CHpSumSdm(I6G4,I6G3,j)
    	enddo
    	enddo
c*
       else
c*
       selfCH=selfCH+(-3*e**2*IndexDelta*myB0i(bb0k,P2,0D0,MassHpm2(i))-3*
     &  CHpHmZ**2*IndexDelta*myB0i(bb0k,P2,MZ2,MassHpm2(i))-2*e**2*
     &  IndexDelta*myB0i(bb1k,P2,0D0,MassHpm2(i))-2*CHpHmZ**2*IndexDelta*
     &  myB0i(bb1k,P2,MZ2,MassHpm2(i))-3*e**2*IndexDelta*P2*
     &  myB0i(dbb0k,P2,0D0,MassHpm2(i))-3*CHpHmZ**2*IndexDelta*P2*
     &  myB0i(dbb0k,P2,MZ2,MassHpm2(i))-2*e**2*IndexDelta*P2*
     &  myB0i(dbb1k,P2,0D0,MassHpm2(i))-2*CHpHmZ**2*IndexDelta*P2*
     &  myB0i(dbb1k,P2,MZ2,MassHpm2(i))+myB0i(dbb0k,P2,MW2,MZ2)*CHmU3U1(j)*
     &  CHmU3U2(i)+myB0i(dbb0k,P2,MW2,MZ2)*CHmU3U1(i)*CHmU3U2(j)+4*
     &  myB0i(dbb0k,P2,0D0,MW2)*CHmWpA(i)*CHmWpA(j)+4*myB0i(dbb0k,P2,MW2,MZ2)
     &  *CHmWpZ(i)*CHmWpZ(j)-e**2*IndexDelta*myB0i(dbb0k,P2,0D0,MassHpm2(i)
     &  )*MassHpm2(i)-CHpHmZ**2*IndexDelta*myB0i(dbb0k,P2,MZ2,MassHpm2(i)
     &  )*MassHpm2(i))
    	do I3G3 = 1,3
       selfCH=selfCH+2*(3*P2*myB0i(dbb0k,P2,MFd2(I3G3),MFu2(I3G3))*
     &  Yd(I3G3)**2*ZP(i,1)*ZP(j,1)+3*P2*myB0i(dbb1k,P2,MFd2(I3G3)
     &  ,MFu2(I3G3))*Yd(I3G3)**2*ZP(i,1)*ZP(j,1)-3*
     &  myB0i(dbb0k,P2,MFd2(I3G3),MFu2(I3G3))*MFu2(I3G3)*Yd(I3G3)**2*
     &  ZP(i,1)*ZP(j,1)+myB0i(bb0k,P2,0D0,MFe2(I3G3))*Ye(I3G3)**2*ZP(i,1)*
     &  ZP(j,1)+myB0i(bb1k,P2,MFe2(I3G3),0D0)*Ye(I3G3)**2*ZP(i,1)*ZP(j,1)+
     &  P2*myB0i(dbb0k,P2,0D0,MFe2(I3G3))*Ye(I3G3)**2*ZP(i,1)*ZP(j,1)+P2*
     &  myB0i(dbb1k,P2,MFe2(I3G3),0D0)*Ye(I3G3)**2*ZP(i,1)*ZP(j,1)-3*
     &  myB0i(dbb0k,P2,MFd2(I3G3),MFu2(I3G3))*MassFd(I3G3)*MassFu(I3G3)*
     &  Yd(I3G3)*Yu(I3G3)*ZP(i,2)*ZP(j,1)-3*myB0i(dbb0k,P2,MFd2(I3G3)
     &  ,MFu2(I3G3))*MassFd(I3G3)*MassFu(I3G3)*Yd(I3G3)*Yu(I3G3)*
     &  ZP(i,1)*ZP(j,2)+3*P2*myB0i(dbb0k,P2,MFd2(I3G3),MFu2(I3G3))*
     &  Yu(I3G3)**2*ZP(i,2)*ZP(j,2)+3*P2*myB0i(dbb1k,P2,MFd2(I3G3)
     &  ,MFu2(I3G3))*Yu(I3G3)**2*ZP(i,2)*ZP(j,2)-3*
     &  myB0i(dbb0k,P2,MFd2(I3G3),MFu2(I3G3))*MFu2(I3G3)*Yu(I3G3)**2*
     &  ZP(i,2)*ZP(j,2)+3*myB0i(bb0k,P2,MFd2(I3G3),MFu2(I3G3))*(Yd(I3G3)*
     &  *2*ZP(i,1)*ZP(j,1)+Yu(I3G3)**2*ZP(i,2)*ZP(j,2))+3*
     &  myB0i(bb1k,P2,MFd2(I3G3),MFu2(I3G3))*(Yd(I3G3)**2*ZP(i,1)*ZP(j,1)
     &  +Yu(I3G3)**2*ZP(i,2)*ZP(j,2)))
    	enddo
    	do I2G3 = 1,2
    	do I5G3 = 1,5
       selfCH=selfCH-2*(myB0i(bb0k,P2,MCha2(I2G3),MNeu2(I5G3))*
     &  (CLHpChiCha(I5G3,I2G3,j)*CRHmChiCha(I2G3,I5G3,i)+
     &  CLHmChiCha(I2G3,I5G3,i)*CRHpChiCha(I5G3,I2G3,j))+
     &  myB0i(bb1k,P2,MCha2(I2G3),MNeu2(I5G3))*(CLHpChiCha(I5G3,I2G3,j)*
     &  CRHmChiCha(I2G3,I5G3,i)+CLHmChiCha(I2G3,I5G3,i)*
     &  CRHpChiCha(I5G3,I2G3,j))+P2*myB0i(dbb1k,P2,MCha2(I2G3)
     &  ,MNeu2(I5G3))*(CLHpChiCha(I5G3,I2G3,j)*CRHmChiCha(I2G3,I5G3,i)+
     &  CLHmChiCha(I2G3,I5G3,i)*CRHpChiCha(I5G3,I2G3,j))-
     &  myB0i(dbb0k,P2,MCha2(I2G3),MNeu2(I5G3))*(CRHpChiCha(I5G3,I2G3,j)*
     &  (CRHmChiCha(I2G3,I5G3,i)*MCha(I2G3)*MNeu(I5G3)+
     &  CLHmChiCha(I2G3,I5G3,i)*(-P2+MNeu2(I5G3)))+
     &  CLHpChiCha(I5G3,I2G3,j)*(CLHmChiCha(I2G3,I5G3,i)*MCha(I2G3)*
     &  MNeu(I5G3)+CRHmChiCha(I2G3,I5G3,i)*(-P2+MNeu2(I5G3)))))
    	enddo
    	enddo
    	do I6G3 = 1,6
       selfCH=selfCH+ChHmWp(i,I6G3)*ChHpWm(I6G3,j)*(3*
     &  myB0i(bb0k,P2,MW2,Masshh2(I6G3))+2*myB0i(bb1k,P2,MW2,Masshh2(I6G3))
     &  +3*P2*myB0i(dbb0k,P2,MW2,Masshh2(I6G3))+2*P2*
     &  myB0i(dbb1k,P2,MW2,Masshh2(I6G3))+myB0i(dbb0k,P2,MW2,Masshh2(I6G3))
     &  *Masshh2(I6G3))
    	enddo
    	do I2G3 = 1,2
    	do I6G3 = 1,6
       selfCH=selfCH-(myB0i(dbb0k,P2,Masshh2(I6G3),MassHpm2(I2G3))*
     &  ChHmHp(i,I2G3,I6G3)*ChHmHp(I2G3,j,I6G3))
    	enddo
    	enddo
    	do I3G3 = 1,3
    	do I6G3 = 1,6
       selfCH=selfCH-(myB0i(dbb0k,P2,MSe2(I6G3),MSv2(I3G3))*
     &  CHmSepSv(I3G3,I6G3,i)*CHpSemSv(I6G3,I3G3,j))
    	enddo
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       selfCH=selfCH-3*myB0i(dbb0k,P2,MSd2(I6G4),MSu2(I6G3))*
     &  CHmSupSdp(I6G3,I6G4,i)*CHpSumSdm(I6G4,I6G3,j)
    	enddo
    	enddo
       endif
       selfCH=selfCH*fac
       return
       end function SelfCH

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Subroutine Selftopfin(P2,i1,i2,selfT,iew)
      implicit none 
      integer i,igen,gt1,gt2,gt3,gt4,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3,I3G5,i1,i2,IndexDelta,
     &          iew,iUV
      integer bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k
      common /funcID/ bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k
      double precision Q,P2,MGL,MGL2,divergence
        
      double precision absM3, phiM3
      common /gluino/ absM3,phiM3
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta 
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)  
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      double complex IC,selfT(4),myB0i

#include "HdecayTCLs.inc"

c nhung tested the two options EMT and Denner give the same value for dmf(i1,i1) because
c only t->bW is open then only diagram with b, W boson in loop contain
c Imaginary part of the loop integral, but the couplings are real
c so there is no contribution of type Im(loop integral)* Im(couplings)

       IC=(0,1D0)
       MGL=absM3;MGL2=MGL**2
       if (i1.eq.i2) then
        IndexDelta=1
       else 
        IndexDelta=0
       endif
       selfT(1:4)=0D0

       if(iew.eq.1)then
       selfT(1)=((16*e**2*(DBLEK(myB0i(bb0k,p2,0D0,MFu2(i1)))+
     &  DBLEK(myB0i(bb1k,p2,0D0,MFu2(i1))))+18*g2**2*
     &  (DBLEK(myB0i(bb0k,p2,MW2,MFd2(i1)))+DBLEK(myB0i(bb1k,p2,MW2,MFd2(i1))
     &  ))+(9*CW2*g2**2+g1*(-6*CW*g2*SW+g1*SW2))*
     &  (DBLEK(myB0i(bb0k,p2,MZ2,MFu2(i1)))+DBLEK(myB0i(bb1k,p2,MZ2,MFu2(i1))
     &  )))*IndexDelta)/18.+selfT(1)
       selfT(2)=(8*(e**2*DBLEK(myB0i(bb0k,p2,0D0,MFu2(i1)))+g1**2*SW2*
     &  DBLEK(myB0i(bb0k,p2,MZ2,MFu2(i1)))+e**2*
     &  DBLEK(myB0i(bb1k,p2,0D0,MFu2(i1)))+g1**2*SW2*
     &  DBLEK(myB0i(bb1k,p2,MZ2,MFu2(i1))))*IndexDelta)/9.+selfT(2)  
       selfT(3)=(-4*(4*e**2*DBLEK(myB0i(bb0k,p2,0D0,MFu2(i1)))+g1*(-3*CW*g2*
     &  SW+g1*SW2)*DBLEK(myB0i(bb0k,p2,MZ2,MFu2(i1))))*IndexDelta*
     &  MassFu(i1))/9.+selfT(3)
       selfT(4)=(-4*(4*e**2*DBLEK(myB0i(bb0k,p2,0D0,MFu2(i1)))+g1*(-3*CW*g2*
     &  SW+g1*SW2)*DBLEK(myB0i(bb0k,p2,MZ2,MFu2(i1))))*IndexDelta*
     &  MassFu(i1))/9.+selfT(4)
    	do I2G3 = 1,2
       selfT(1)=selfT(1)-(DBLEK(myB0i(bb1k,p2,MFd2(i1),MassHpm2(I2G3)))*
     &  IndexDelta*Yd(i1)*Yd(i2)*ZP(I2G3,1)**2)
       selfT(2)=selfT(2)-(DBLEK(myB0i(bb1k,p2,MFd2(i1),MassHpm2(I2G3)))*
     &  IndexDelta*Yu(i1)*Yu(i2)*ZP(I2G3,2)**2)
       selfT(3)=selfT(3)+DBLEK(myB0i(bb0k,p2,MassHpm2(I2G3),MFd2(i1)))*
     &  IndexDelta*MassFd(i1)*Yd(i1)*Yu(i2)*ZP(I2G3,1)*
     &  ZP(I2G3,2)
       selfT(4)=selfT(4)+DBLEK(myB0i(bb0k,p2,MassHpm2(I2G3),MFd2(i1)))*
     &  IndexDelta*MassFd(i1)*Yd(i2)*Yu(i1)*ZP(I2G3,1)*
     &  ZP(I2G3,2)
    	enddo
    	do I6G3 = 1,6
       selfT(1)=CLhFumFup(i1,i1,I6G3)*CRhFumFup(i2,i1,I6G3)*
     &  DBLEK(myB0i(bb1k,p2,MFu2(i1),Masshh2(I6G3)))*IndexDelta+
     &  selfT(1)
       selfT(2)=CLhFumFup(i2,i1,I6G3)*CRhFumFup(i1,i1,I6G3)*
     &  DBLEK(myB0i(bb1k,p2,MFu2(i1),Masshh2(I6G3)))*IndexDelta+
     &  selfT(2)
       selfT(3)=-(CLhFumFup(i1,i1,I6G3)*CLhFumFup(i2,i1,I6G3)*
     &  DBLEK(myB0i(bb0k,p2,Masshh2(I6G3),MFu2(i1)))*IndexDelta*
     &  MassFu(i1))+selfT(3)
       selfT(4)=-(CRhFumFup(i1,i1,I6G3)*CRhFumFup(i2,i1,I6G3)*
     &  DBLEK(myB0i(bb0k,p2,Masshh2(I6G3),MFu2(i1)))*IndexDelta*
     &  MassFu(i1))+selfT(4)
    	enddo
    	do I2G3 = 1,2
    	do I6G3 = 1,6
       selfT(1)=-(cupchapsdL(I2G3,i1,I6G3)*DBLEK(myB0i(bb1k,p2,MCha2(I2G3)
     &  ,MSd2(I6G3)))*DCONJG(cupchapsdL(I2G3,i2,I6G3)))+selfT(1)
       selfT(2)=-(cupchapsdR(I2G3,i1,I6G3)*DBLEK(myB0i(bb1k,p2,MCha2(I2G3)
     &  ,MSd2(I6G3)))*DCONJG(cupchapsdR(I2G3,i2,I6G3)))+selfT(2)
       selfT(3)=cupchapsdL(I2G3,i1,I6G3)*DBLEK(myB0i(bb0k,p2,MCha2(I2G3)
     &  ,MSd2(I6G3)))*DCONJG(cupchapsdR(I2G3,i2,I6G3))*MCha(I2G3)+
     &  selfT(3)
       selfT(4)=cupchapsdR(I2G3,i1,I6G3)*DBLEK(myB0i(bb0k,p2,MCha2(I2G3)
     &  ,MSd2(I6G3)))*DCONJG(cupchapsdL(I2G3,i2,I6G3))*MCha(I2G3)+
     &  selfT(4)
    	enddo
    	enddo
    	do I5G3 = 1,5
    	do I6G3 = 1,6
       selfT(1)=-(cchiupsumL(I5G3,i1,I6G3)*DBLEK(myB0i(bb1k,p2,MNeu2(I5G3)
     &  ,MSu2(I6G3)))*DCONJG(cchiupsumL(I5G3,i2,I6G3)))+selfT(1)
       selfT(2)=-(cchiupsumR(I5G3,i1,I6G3)*DBLEK(myB0i(bb1k,p2,MNeu2(I5G3)
     &  ,MSu2(I6G3)))*DCONJG(cchiupsumR(I5G3,i2,I6G3)))+selfT(2)
       selfT(3)=cchiupsumL(I5G3,i1,I6G3)*DBLEK(myB0i(bb0k,p2,MNeu2(I5G3)
     &  ,MSu2(I6G3)))*DCONJG(cchiupsumR(I5G3,i2,I6G3))*MNeu(I5G3)+
     &  selfT(3)
       selfT(4)=cchiupsumR(I5G3,i1,I6G3)*DBLEK(myB0i(bb0k,p2,MNeu2(I5G3)
     &  ,MSu2(I6G3)))*DCONJG(cchiupsumL(I5G3,i2,I6G3))*MNeu(I5G3)+
     &  selfT(4)
    	enddo
    	enddo
       elseif(iew.eq.2)then
       selfT(1)=(8*g3**2*IndexDelta*(DBLEK(myB0i(bb0k,p2,0D0,MFu2(i1)))+
     &  DBLEK(myB0i(bb1k,p2,0D0,MFu2(i1)))))/3.+selfT(1)
       selfT(2)=(8*g3**2*IndexDelta*(DBLEK(myB0i(bb0k,p2,0D0,MFu2(i1)))+
     &  DBLEK(myB0i(bb1k,p2,0D0,MFu2(i1)))))/3.+selfT(2)
       selfT(3)=(-16*g3**2*IndexDelta*DBLEK(myB0i(bb0k,p2,0D0,MFu2(i1)))*
     &  MassFu(i1))/3.+selfT(3)
       selfT(4)=(-16*g3**2*IndexDelta*DBLEK(myB0i(bb0k,p2,0D0,MFu2(i1)))*
     &  MassFu(i1))/3.+selfT(4)

    	do I6G3 = 1,6
       selfT(1)=(-4*g3**2*CF15usuL(i1,I6G3)*
     &  DBLEK(myB0i(bb1k,p2,MGL2,MSu2(I6G3)))*DCONJG(CF15usuL(i2,I6G3)))
     &  /3.+selfT(1)
       selfT(2)=(-4*g3**2*CF15usuR(i1,I6G3)*
     &  DBLEK(myB0i(bb1k,p2,MGL2,MSu2(I6G3)))*DCONJG(CF15usuR(i2,I6G3)))
     &  /3.+selfT(2)
       selfT(3)=(-4*g3**2*CF15usuL(i1,I6G3)*
     &  DBLEK(myB0i(bb0k,p2,MGL2,MSu2(I6G3)))*DCONJG(CF15usuR(i2,I6G3))*
     &  MGL)/3.+selfT(3)
       selfT(4)=(-4*g3**2*CF15usuR(i1,I6G3)*
     &  DBLEK(myB0i(bb0k,p2,MGL2,MSu2(I6G3)))*DCONJG(CF15usuL(i2,I6G3))*
     &  MGL)/3.+selfT(4)
    	enddo
       endif

       selfT(1:4)=       selfT(1:4)*fac

       end Subroutine Selftopfin

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Subroutine Selfbottomfin(P2,i1,i2,selfB,iew)
      implicit none
      integer i,igen,gt1,gt2,gt3,gt4,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3,I3G5,i1,i2,IndexDelta,
     &          iew

      integer bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k
      common /funcID/ bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k
      double precision Q,P2,MGL,MGL2,divergence
        

      double precision absM3,phiM3
      common /gluino/ absM3,phiM3

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
    
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)

      double precision ZH5(5,5),ZH(6,6)    
      double complex UM(2,2),UP(2,2),NN(5,5),ZEN(6,6),ZDN(6,6),ZUN(6,6)
  
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv

      double complex IC,selfB(4),myB0i

#include "HdecayTCLs.inc"
c nhung tested the two options give the same value for dmf(i1,i1) because
c so there is no contribution of type Im(loop integral)* Im(couplings)

        IC=(0,1D0)
        MGL=absM3;MGL2=MGL**2
       if (i1.eq.i2) then
        IndexDelta=1
       else 
        IndexDelta=0
       endif
       selfB(1:4)=0D0
       if(iew.eq.1)then
       selfB(1)=(IndexDelta*(4*e**2*(DBLEK(myB0i(bb0k,p2,0D0,MFd2(i1)))+
     &  DBLEK(myB0i(bb1k,p2,0D0,MFd2(i1))))+18*g2**2*
     &  (DBLEK(myB0i(bb0k,p2,MW2,MFu2(i1)))+DBLEK(myB0i(bb1k,p2,MW2,MFu2(i1))
     &  ))+(9*CW2*g2**2+g1*(6*CW*g2*SW+g1*SW2))*
     &  (DBLEK(myB0i(bb0k,p2,MZ2,MFd2(i1)))+DBLEK(myB0i(bb1k,p2,MZ2,MFd2(i1))
     &  ))))/18.+selfB(1)
       selfB(2)=(2*IndexDelta*(e**2*DBLEK(myB0i(bb0k,p2,0D0,MFd2(i1)))+g1**
     &  2*SW2*DBLEK(myB0i(bb0k,p2,MZ2,MFd2(i1)))+e**2*
     &  DBLEK(myB0i(bb1k,p2,0D0,MFd2(i1)))+g1**2*SW2*
     &  DBLEK(myB0i(bb1k,p2,MZ2,MFd2(i1)))))/9.+selfB(2)
       selfB(3)=(-2*IndexDelta*(2*e**2*DBLEK(myB0i(bb0k,p2,0D0,MFd2(i1)))-
     &  g1*(3*CW*g2*SW+g1*SW2)*DBLEK(myB0i(bb0k,p2,MZ2,MFd2(i1))))*
     &  MassFd(i1))/9.+selfB(3)
       selfB(4)=(-2*IndexDelta*(2*e**2*DBLEK(myB0i(bb0k,p2,0D0,MFd2(i1)))-
     &  g1*(3*CW*g2*SW+g1*SW2)*DBLEK(myB0i(bb0k,p2,MZ2,MFd2(i1))))*
     &  MassFd(i1))/9.+selfB(4)

    	do I2G3 = 1,2
       selfB(1)=selfB(1)-(DBLEK(myB0i(bb1k,p2,MFu2(i1),MassHpm2(I2G3)))*
     &  IndexDelta*Yu(i1)*Yu(i2)*ZP(I2G3,2)**2)
       selfB(2)=selfB(2)-(IndexDelta*DBLEK(myB0i(bb1k,p2,MFu2(i1)
     &  ,MassHpm2(I2G3)))*Yd(i1)*Yd(i2)*ZP(I2G3,1)**2)
       selfB(3)=selfB(3)+IndexDelta*DBLEK(myB0i(bb0k,p2,MassHpm2(I2G3)
     &  ,MFu2(i1)))*MassFu(i1)*Yd(i2)*Yu(i1)*ZP(I2G3,1)*ZP(I2G3,2)
       selfB(4)=selfB(4)+IndexDelta*DBLEK(myB0i(bb0k,p2,MassHpm2(I2G3)
     &  ,MFu2(i1)))*MassFu(i1)*Yd(i1)*Yu(i2)*ZP(I2G3,1)*ZP(I2G3,2)
    	enddo
    	do I6G3 = 1,6
       selfB(1)=CLhFdpFdm(i1,i1,I6G3)*CRhFdpFdm(i2,i1,I6G3)*
     &  DBLEK(myB0i(bb1k,p2,MFd2(i1),Masshh2(I6G3)))*IndexDelta+
     &  selfB(1)
       selfB(2)=IndexDelta*CLhFdpFdm(i2,i1,I6G3)*CRhFdpFdm(i1,i1,I6G3)*
     &  DBLEK(myB0i(bb1k,p2,MFd2(i1),Masshh2(I6G3)))+selfB(2)
       selfB(3)=-(IndexDelta*CLhFdpFdm(i1,i1,I6G3)*
     &  CLhFdpFdm(i2,i1,I6G3)*DBLEK(myB0i(bb0k,p2,Masshh2(I6G3),MFd2(i1)))
     &  *MassFd(i1))+selfB(3)
       selfB(4)=-(IndexDelta*CRhFdpFdm(i1,i1,I6G3)*
     &  CRhFdpFdm(i2,i1,I6G3)*DBLEK(myB0i(bb0k,p2,Masshh2(I6G3),MFd2(i1)))
     &  *MassFd(i1))+selfB(4)
    	enddo

    	do I2G3 = 1,2
    	do I6G3 = 1,6
       selfB(1)=-(cdmchapsuR(i2,I2G3,I6G3)*DBLEK(myB0i(bb1k,p2,MCha2(I2G3)
     &  ,MSu2(I6G3)))*DCONJG(cdmchapsuR(i1,I2G3,I6G3)))+selfB(1)
       selfB(2)=-(cdmchapsuL(i2,I2G3,I6G3)*DBLEK(myB0i(bb1k,p2,MCha2(I2G3)
     &  ,MSu2(I6G3)))*DCONJG(cdmchapsuL(i1,I2G3,I6G3)))+selfB(2)
       selfB(3)=cdmchapsuL(i2,I2G3,I6G3)*DBLEK(myB0i(bb0k,p2,MCha2(I2G3)
     &  ,MSu2(I6G3)))*DCONJG(cdmchapsuR(i1,I2G3,I6G3))*MCha(I2G3)+
     &  selfB(3)
       selfB(4)=cdmchapsuR(i2,I2G3,I6G3)*DBLEK(myB0i(bb0k,p2,MCha2(I2G3)
     &  ,MSu2(I6G3)))*DCONJG(cdmchapsuL(i1,I2G3,I6G3))*MCha(I2G3)+
     &  selfB(4)
    	enddo
    	enddo

    	do I5G3 = 1,5
    	do I6G3 = 1,6
       selfB(1)=-(cchidmsdpL(I5G3,i1,I6G3)*DBLEK(myB0i(bb1k,p2,MNeu2(I5G3)
     &  ,MSd2(I6G3)))*DCONJG(cchidmsdpL(I5G3,i2,I6G3)))+selfB(1)
       selfB(2)=-(cchidmsdpR(I5G3,i1,I6G3)*DBLEK(myB0i(bb1k,p2,MNeu2(I5G3)
     &  ,MSd2(I6G3)))*DCONJG(cchidmsdpR(I5G3,i2,I6G3)))+selfB(2)
       selfB(3)=cchidmsdpL(I5G3,i1,I6G3)*DBLEK(myB0i(bb0k,p2,MNeu2(I5G3)
     &  ,MSd2(I6G3)))*DCONJG(cchidmsdpR(I5G3,i2,I6G3))*MNeu(I5G3)+
     &  selfB(3)
       selfB(4)=cchidmsdpR(I5G3,i1,I6G3)*DBLEK(myB0i(bb0k,p2,MNeu2(I5G3)
     &  ,MSd2(I6G3)))*DCONJG(cchidmsdpL(I5G3,i2,I6G3))*MNeu(I5G3)+
     &  selfB(4)
    	enddo
    	enddo
       elseif(iew.eq.2)then

       selfB(1)=(8*g3**2*IndexDelta*(DBLEK(myB0i(bb0k,p2,0D0,MFd2(i1)))+
     &  DBLEK(myB0i(bb1k,p2,0D0,MFd2(i1)))))/3.+selfB(1)
       selfB(2)=(8*g3**2*IndexDelta*(DBLEK(myB0i(bb0k,p2,0D0,MFd2(i1)))+
     &  DBLEK(myB0i(bb1k,p2,0D0,MFd2(i1)))))/3.+selfB(2)
       selfB(3)=(-16*g3**2*IndexDelta*DBLEK(myB0i(bb0k,p2,0D0,MFd2(i1)))*
     &  MassFd(i1))/3.+selfB(3)
       selfB(4)=(-16*g3**2*IndexDelta*DBLEK(myB0i(bb0k,p2,0D0,MFd2(i1)))*
     &  MassFd(i1))/3.+selfB(4)
    	do I6G3 = 1,6
       selfB(1)=(-4*g3**2*CF15dsdL(i1,I6G3)*
     &  DBLEK(myB0i(bb1k,p2,MGL2,MSd2(I6G3)))*DCONJG(CF15dsdL(i2,I6G3)))
     &  /3.+selfB(1)
       selfB(2)=(-4*g3**2*CF15dsdR(i1,I6G3)*
     &  DBLEK(myB0i(bb1k,p2,MGL2,MSd2(I6G3)))*DCONJG(CF15dsdR(i2,I6G3)))
     &  /3.+selfB(2)
       selfB(3)=(-4*g3**2*CF15dsdL(i1,I6G3)*
     &  DBLEK(myB0i(bb0k,p2,MGL2,MSd2(I6G3)))*DCONJG(CF15dsdR(i2,I6G3))*
     &  MGL)/3.+selfB(3)
       selfB(4)=(-4*g3**2*CF15dsdR(i1,I6G3)*
     &  DBLEK(myB0i(bb0k,p2,MGL2,MSd2(I6G3)))*DCONJG(CF15dsdL(i2,I6G3))*
     &  MGL)/3.+selfB(4)
    	enddo
       endif
       selfB(1:4)= selfB(1:4)*fac

       end subroutine Selfbottomfin

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Subroutine SelfSbottomReti(P2,i1,i2,self,iew,iuv)
      implicit none

      integer i,igen,gt1,gt2,gt3,gt4,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3,I3G5,i1,i2,IndexDelta,
     &          iew,iuv
      integer bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k
      common /funcID/ bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k
      double precision Q,P2,MGL,MGL2,divergence,myA0
        
      double precision absM3, phiM3
      common /gluino/ absM3,phiM3

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3   
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double complex IC,self,myB0i
#include "HdecayTCLs.inc"

      if(iuv.eq.1)then
        self=0D0
        return
      endif
        MGL=absM3;MGL2=MGL**2
        IC=(0,1D0)
       if (i1.eq.i2) then
        IndexDelta=1
       else 
        IndexDelta=0
       endif

       self=0D0

       if(iew.eq.1)then

       self=(36*myA0(MW2)*CSdSdWW(i2,i1)+18*myA0(MZ2)*CSdSdZZ(i2,i1)
     &  -IndexDelta* e**2*(2*p2*DBLE(myB0i(bb1k,p2,0D0,MSd2(i1)))+
     &  DBLE(myB0i(bb0k,p2,0D0,MSd2(i1)))*(3*p2+MSd2(i1))))/9.

    	do I2G3 = 1,2
       self=self+IC*myA0(MassHpm2(I2G3))*CHmHpSdmSdp(i2,I2G3,i1,I2G3)
    	enddo

    	do I3G3 = 1,3
       self=self-(myA0(MSv2(I3G3))*CSd2Sv2(i2,i1,I3G3))
    	enddo


    	do I2G3 = 1,2
    	do I3G3 = 1,3
       self=self-2*(myA0(MCha2(I2G3))*(cupchapsdL(I2G3,I3G3,i1)*
     &  DCONJG(cupchapsdL(I2G3,I3G3,i2))+cupchapsdR(I2G3,I3G3,i1)*
     &  DCONJG(cupchapsdR(I2G3,I3G3,i2)))+cupchapsdL(I2G3,I3G3,i1)*(-
     &  (p2*DBLE(myB0i(bb1k,p2,MCha2(I2G3),MFu2(I3G3)))*
     &  DCONJG(cupchapsdL(I2G3,I3G3,i2)))+DBLE(myB0i(bb0k,p2,MCha2(I2G3)
     &  ,MFu2(I3G3)))*(DCONJG(cupchapsdR(I2G3,I3G3,i2))*MassFu(I3G3)*
     &  sqrt(MCha2(I2G3))+DCONJG(cupchapsdL(I2G3,I3G3,i2))*(-p2+MFu2(I3G3))))+
     &  cupchapsdR(I2G3,I3G3,i1)*(-(p2*DBLE(myB0i(bb1k,p2,MCha2(I2G3)
     &  ,MFu2(I3G3)))*DCONJG(cupchapsdR(I2G3,I3G3,i2)))+
     &  DBLE(myB0i(bb0k,p2,MCha2(I2G3),MFu2(I3G3)))*
     &  (DCONJG(cupchapsdL(I2G3,I3G3,i2))*MassFu(I3G3)*sqrt(MCha2(I2G3))+
     &  DCONJG(cupchapsdR(I2G3,I3G3,i2))*(-p2+MFu2(I3G3)))))
    	enddo
    	enddo


    	do I3G3 = 1,3
    	do I5G3 = 1,5
       self=self-2*(myA0(MNeu2(I5G3))*(cchidmsdpL(I5G3,I3G3,i1)*
     &  DCONJG(cchidmsdpL(I5G3,I3G3,i2))+cchidmsdpR(I5G3,I3G3,i1)*
     &  DCONJG(cchidmsdpR(I5G3,I3G3,i2)))+cchidmsdpR(I5G3,I3G3,i1)*(-
     &  (p2*DBLE(myB0i(bb1k,p2,MNeu2(I5G3),MFd2(I3G3)))*
     &  DCONJG(cchidmsdpR(I5G3,I3G3,i2)))+DBLE(myB0i(bb0k,p2,MFd2(I3G3)
     &  ,MNeu2(I5G3)))*(DCONJG(cchidmsdpR(I5G3,I3G3,i2))*(-p2+
     &  MFd2(I3G3))+DCONJG(cchidmsdpL(I5G3,I3G3,i2))*MassFd(I3G3)*
     &  MNeu(I5G3)))+cchidmsdpL(I5G3,I3G3,i1)*(-(p2*
     &  DBLE(myB0i(bb1k,p2,MNeu2(I5G3),MFd2(I3G3)))*
     &  DCONJG(cchidmsdpL(I5G3,I3G3,i2)))+DBLE(myB0i(bb0k,p2,MFd2(I3G3)
     &  ,MNeu2(I5G3)))*(DCONJG(cchidmsdpL(I5G3,I3G3,i2))*(-p2+
     &  MFd2(I3G3))+DCONJG(cchidmsdpR(I5G3,I3G3,i2))*MassFd(I3G3)*MNeu(I5G3))))
    	enddo
    	enddo

c        print*,  'without sfermion', self*fac
c           self=0D0
    	do I6G3 = 1,6
       self=self+((IC*myA0(Masshh2(I6G3))*ChhSdmSdp(i2,I6G3,i1,I6G3))
     &  /2.-myA0(MSe2(I6G3))*CSd2Se2(i2,i1,I6G3,I6G3)-myA0(MSd2(I6G3))*
     &  CSd4p1(i2,I6G3,i1,I6G3)-3*myA0(MSd2(I6G3))*
     &  CSd4p2(i2,I6G3,i1,I6G3)-myA0(MZ2)*CsdmsdpZ(i2,I6G3)*
     &  CsdmsdpZ(I6G3,i1)-3*myA0(MSu2(I6G3))*CSu2Sd2p1(I6G3,I6G3,i2,i1)-
     &  myA0(MSu2(I6G3))*CSu2Sd2p2(I6G3,I6G3,i2,i1)-3*p2*
     &  CsdmsdpZ(i2,I6G3)*CsdmsdpZ(I6G3,i1)*
     &  DBLE(myB0i(bb0k,p2,MZ2,MSd2(I6G3)))-2*p2*CsdmsdpZ(i2,I6G3)*
     &  CsdmsdpZ(I6G3,i1)*DBLE(myB0i(bb1k,p2,MZ2,MSd2(I6G3)))-myA0(MW2)*
     &  CsdsuW(i2,I6G3)*DCONJG(CsdsuW(i1,I6G3))-3*p2*CsdsuW(i2,I6G3)*
     &  DBLE(myB0i(bb0k,p2,MW2,MSu2(I6G3)))*DCONJG(CsdsuW(i1,I6G3))-2*
     &  p2*CsdsuW(i2,I6G3)*DBLE(myB0i(bb1k,p2,MW2,MSu2(I6G3)))*
     &  DCONJG(CsdsuW(i1,I6G3))-CsdmsdpZ(i2,I6G3)*CsdmsdpZ(I6G3,i1)*
     &  DBLE(myB0i(bb0k,p2,MZ2,MSd2(I6G3)))*MSd2(I6G3)-CsdsuW(i2,I6G3)*
     &  DBLE(myB0i(bb0k,p2,MW2,MSu2(I6G3)))*DCONJG(CsdsuW(i1,I6G3))*
     &  MSu2(I6G3))
    	enddo
    	do I2G3 = 1,2
    	do I6G3 = 1,6
       self=self-(CHmSupSdp(I6G3,i1,I2G3)*CHpSumSdm(i2,I6G3,I2G3)*
     &  DBLE(myB0i(bb0k,p2,MassHpm2(I2G3),MSu2(I6G3))))
    	enddo
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       self=self-(ChSdmSdp(i2,I6G4,I6G3)*ChSdmSdp(I6G4,i1,I6G3)*
     &  DBLE(myB0i(bb0k,p2,Masshh2(I6G3),MSd2(I6G4))))
    	enddo
    	enddo
       elseif(iew.eq.2)then
       self=(-4*g3**2*IndexDelta*(2*p2*
     &  DBLE(myB0i(bb1k,p2,0D0,MSd2(i1)))+DBLE(myB0i(bb0k,p2,0D0,MSd2(i1)))*
     &  (3*p2+MSd2(i1))))/3.

    	do I3G3 = 1,3
       self=self+(-8*g3**2*(myA0(MGL2)*(CF15dsdL(I3G3,i1)*
     &  DCONJG(CF15dsdL(I3G3,i2))+CF15dsdR(I3G3,i1)*
     &  DCONJG(CF15dsdR(I3G3,i2)))+CF15dsdL(I3G3,i1)*(p2*
     &  DBLE(myB0i(bb1k,p2,MFd2(I3G3),MGL2))*DCONJG(CF15dsdL(I3G3,i2))+
     &  DBLE(myB0i(bb0k,p2,MGL2,MFd2(I3G3)))*(-(DCONJG(CF15dsdR(I3G3,i2)
     &  )*MassFd(I3G3)*MGL)+DCONJG(CF15dsdL(I3G3,i2))*
     &  MFd2(I3G3)))+CF15dsdR(I3G3,i1)*(p2*DBLE(myB0i(bb1k,p2,MFd2(I3G3)
     &  ,MGL2))*DCONJG(CF15dsdR(I3G3,i2))+
     &  DBLE(myB0i(bb0k,p2,MGL2,MFd2(I3G3)))*(-(DCONJG(CF15dsdL(I3G3,i2)
     &  )*MassFd(I3G3)*MGL)+DCONJG(CF15dsdR(I3G3,i2))*
     &  MFd2(I3G3)))))/3.
    	enddo

    	do I6G3 = 1,6
       self=self+(-(g3**2*myA0(MSd2(I6G3))*(+
     &  CSd4p1QCD(i2,I6G3,i1,I6G3)+3*
     &  CSd4p2QCD(i2,I6G3,i1,I6G3)))-g3**2*myA0(MSu2(I6G3))*(3*
     &  CSu2Sd2p1QCD(I6G3,I6G3,i2,i1)+CSu2Sd2p2QCD(I6G3,I6G3,i2,i1)))
    	enddo
       endif

       self=self*fac
       end Subroutine SelfSbottomReti

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      Subroutine SelfStopReti(P2,i1,i2,self,iEW,iuv)
      implicit none 
      integer i,igen,gt1,gt2,gt3,gt4,I2G3,I2G4,I2G5,I2G6,I5G3,I5G4,
     &          I5G5,I6G3,I6G4,I6G5,I3G4,I5G6,I6G6,I3G3,I3G5,i1,i2,
     &          IndexDelta,iEW,iuv
      integer bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k
      common /funcID/ bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k

      double precision Q,P2,MGL,MGL2,divergence,myA0
        
      double precision absM3, phiM3
      common /gluino/ absM3,phiM3

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)

      double precision ZH5(5,5),ZH(6,6)    
      double complex UM(2,2),UP(2,2),NN(5,5),ZEN(6,6),ZDN(6,6),ZUN(6,6)
    
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3

      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv

      common /rot/ ZH5,ZH,UM,UP,NN,ZEN,ZDN,ZUN

      double complex IC,x,self,myB0i
#include "HdecayTCLs.inc"

       if (iuv.eq.1)then
        self=0
	return
       endif


        IC=(0,1D0)
        MGL=absM3;MGL2=MGL**2
       if (i1.eq.i2) then
        IndexDelta=1
       else 
        IndexDelta=0
       endif
       self=0D0


       if (iew.eq.1)then
       self=self+(-2*(-18*myA0(MW2)*CSuSuWW(i2,i1)-9*myA0(MZ2)*
     &  CSuSuZZ(i2,i1)+2*e**2*IndexDelta*(2*p2*
     &  DBLE(myB0i(bb1k,p2,0D0,MSu2(i1)))+DBLE(myB0i(bb0k,p2,0D0,MSu2(i1)))*
     &  (3*p2+MSu2(i1)))))/9.

c this change does not give uv finite result 
c       self=self+(-2*(-18*myA0(MW2)*CSuSuWW(i2,i1)-9*myA0(MZ2)*
c     &  CSuSuZZ(i2,i1)+2*e**2*IndexDelta*(2*p2*
c     &  DBLE(myB0i(bb1k,p2,0D0,P2))+DBLE(myB0i(bb0k,p2,0D0,P2))*
c     &  (3*p2+P2))))/9.

    	do I2G3 = 1,2
       self=self+IC*myA0(MassHpm2(I2G3))*CHmHpSupSum(i2,I2G3,i1,I2G3)
    	enddo
    	do I3G3 = 1,3
       self=self-(myA0(MSv2(I3G3))*CSu2Sv2(i2,i1,I3G3))
    	enddo
    	do I2G3 = 1,2
    	do I3G3 = 1,3
       self=self-2*(myA0(MCha2(I2G3))*(cdmchapsuL(I3G3,I2G3,i2)*
     &  DCONJG(cdmchapsuL(I3G3,I2G3,i1))+cdmchapsuR(I3G3,I2G3,i2)*
     &  DCONJG(cdmchapsuR(I3G3,I2G3,i1)))+cdmchapsuL(I3G3,I2G3,i2)*(-
     &  (p2*DBLE(myB0i(bb1k,p2,MCha2(I2G3),MFd2(I3G3)))*
     &  DCONJG(cdmchapsuL(I3G3,I2G3,i1)))+DBLE(myB0i(bb0k,p2,MCha2(I2G3)
     &  ,MFd2(I3G3)))*(DCONJG(cdmchapsuR(I3G3,I2G3,i1))*MassFd(I3G3)*
     &  MCha(I2G3)+DCONJG(cdmchapsuL(I3G3,I2G3,i1))*(-p2+MFd2(I3G3))))+
     &  cdmchapsuR(I3G3,I2G3,i2)*(-(p2*DBLE(myB0i(bb1k,p2,MCha2(I2G3)
     &  ,MFd2(I3G3)))*DCONJG(cdmchapsuR(I3G3,I2G3,i1)))+
     &  DBLE(myB0i(bb0k,p2,MCha2(I2G3),MFd2(I3G3)))*
     &  (DCONJG(cdmchapsuL(I3G3,I2G3,i1))*MassFd(I3G3)*MCha(I2G3)+
     &  DCONJG(cdmchapsuR(I3G3,I2G3,i1))*(-p2+MFd2(I3G3)))))
    	enddo
    	enddo
    	do I3G3 = 1,3
    	do I5G3 = 1,5
       self=self-2*(myA0(MNeu2(I5G3))*(cchiupsumL(I5G3,I3G3,i1)*
     &  DCONJG(cchiupsumL(I5G3,I3G3,i2))+cchiupsumR(I5G3,I3G3,i1)*
     &  DCONJG(cchiupsumR(I5G3,I3G3,i2)))+cchiupsumR(I5G3,I3G3,i1)*(-
     &  (p2*DBLE(myB0i(bb1k,p2,MNeu2(I5G3),MFu2(I3G3)))*
     &  DCONJG(cchiupsumR(I5G3,I3G3,i2)))+DBLE(myB0i(bb0k,p2,MFu2(I3G3)
     &  ,MNeu2(I5G3)))*(DCONJG(cchiupsumR(I5G3,I3G3,i2))*(-p2+
     &  MFu2(I3G3))+DCONJG(cchiupsumL(I5G3,I3G3,i2))*MassFu(I3G3)*
     &  MNeu(I5G3)))+cchiupsumL(I5G3,I3G3,i1)*(-(p2*
     &  DBLE(myB0i(bb1k,p2,MNeu2(I5G3),MFu2(I3G3)))*
     &  DCONJG(cchiupsumL(I5G3,I3G3,i2)))+DBLE(myB0i(bb0k,p2,MFu2(I3G3)
     &  ,MNeu2(I5G3)))*(DCONJG(cchiupsumL(I5G3,I3G3,i2))*(-p2+
     &  MFu2(I3G3))+DCONJG(cchiupsumR(I5G3,I3G3,i2))*MassFu(I3G3)*MNeu(I5G3))))
    	enddo
    	enddo
    	do I6G3 = 1,6
       self=self+((IC*myA0(Masshh2(I6G3))*ChhSupSum(i2,I6G3,i1,I6G3))
     &  /2.-myA0(MSd2(I6G3))*(3*CSu2Sd2p1(i2,i1,I6G3,I6G3)+
     &  CSu2Sd2p2(i2,i1,I6G3,I6G3))-myA0(MSe2(I6G3))*
     &  CSu2Se2(i2,i1,I6G3,I6G3)-myA0(MSu2(I6G3))*
     &  CSu4p1(i2,I6G3,i1,I6G3)-3*myA0(MSu2(I6G3))*
     &  CSu4p2(i2,I6G3,i1,I6G3)-myA0(MZ2)*CsupsumZ(i2,I6G3)*
     &  CsupsumZ(I6G3,i1)-3*p2*CsupsumZ(i2,I6G3)*CsupsumZ(I6G3,i1)*
     &  DBLE(myB0i(bb0k,p2,MZ2,MSu2(I6G3)))-2*p2*CsupsumZ(i2,I6G3)*
     &  CsupsumZ(I6G3,i1)*DBLE(myB0i(bb1k,p2,MZ2,MSu2(I6G3)))-myA0(MW2)*
     &  CsdsuW(I6G3,i1)*DCONJG(CsdsuW(I6G3,i2))-3*p2*CsdsuW(I6G3,i1)*
     &  DBLE(myB0i(bb0k,p2,MW2,MSd2(I6G3)))*DCONJG(CsdsuW(I6G3,i2))-2*
     &  p2*CsdsuW(I6G3,i1)*DBLE(myB0i(bb1k,p2,MW2,MSd2(I6G3)))*
     &  DCONJG(CsdsuW(I6G3,i2))-CsdsuW(I6G3,i1)*
     &  DBLE(myB0i(bb0k,p2,MW2,MSd2(I6G3)))*DCONJG(CsdsuW(I6G3,i2))*
     &  MSd2(I6G3)-CsupsumZ(i2,I6G3)*CsupsumZ(I6G3,i1)*
     &  DBLE(myB0i(bb0k,p2,MZ2,MSu2(I6G3)))*MSu2(I6G3))
    	enddo
    	do I2G3 = 1,2
    	do I6G3 = 1,6
       self=self-(CHmSupSdp(i2,I6G3,I2G3)*CHpSumSdm(I6G3,i1,I2G3)*
     &  DBLE(myB0i(bb0k,p2,MassHpm2(I2G3),MSd2(I6G3))))
    	enddo
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       self=self-(ChSupSum(i2,I6G4,I6G3)*ChSupSum(I6G4,i1,I6G3)*
     &  DBLE(myB0i(bb0k,p2,Masshh2(I6G3),MSu2(I6G4))))
    	enddo
    	enddo
        elseif(iew.eq.2)then

       self=self+(-4*g3**2*IndexDelta*(2*p2*
     &  DBLE(myB0i(bb1k,p2,0D0,MSu2(i1)))+DBLE(myB0i(bb0k,p2,0D0,MSu2(i1)))*
     &  (3*p2+MSu2(i1))))/3.

c       self=self+(-4*g3**2*IndexDelta*(2*p2*
c     &  DBLE(myB0i(bb1k,p2,0D0,P2))+DBLE(myB0i(bb0k,p2,0D0,P2))*
c     &  (3*p2+P2)))/3.
    	do I3G3 = 1,3
       self=self+(-8*g3**2*(myA0(MGL2)*(CF15usuL(I3G3,i1)*
     &  DCONJG(CF15usuL(I3G3,i2))+CF15usuR(I3G3,i1)*
     &  DCONJG(CF15usuR(I3G3,i2)))+CF15usuL(I3G3,i1)*(p2*
     &  DBLE(myB0i(bb1k,p2,MFu2(I3G3),MGL2))*DCONJG(CF15usuL(I3G3,i2))+
     &  DBLE(myB0i(bb0k,p2,MGL2,MFu2(I3G3)))*(-(DCONJG(CF15usuR(I3G3,i2)
     &  )*MassFu(I3G3)*MGL)+DCONJG(CF15usuL(I3G3,i2))*
     &  MFu2(I3G3)))+CF15usuR(I3G3,i1)*(p2*DBLE(myB0i(bb1k,p2,MFu2(I3G3)
     &  ,MGL2))*DCONJG(CF15usuR(I3G3,i2))+
     &  DBLE(myB0i(bb0k,p2,MGL2,MFu2(I3G3)))*(-(DCONJG(CF15usuL(I3G3,i2)
     &  )*MassFu(I3G3)*MGL)+DCONJG(CF15usuR(I3G3,i2))*
     &  MFu2(I3G3)))))/3.
    	enddo

    	do I6G3 = 1,6
       self=self-(g3**2*(myA0(MSd2(I6G3))*(3*CSu2Sd2p1QCD(i2,i1,I6G3,I6G3)
     &  +CSu2Sd2p2QCD(i2,i1,I6G3,I6G3))+myA0(MSu2(I6G3))*
     &  (CSu4p1QCD(i2,I6G3,i1,I6G3)+3*CSu4p2QCD(i2,I6G3,i1,I6G3))))
    	enddo
        endif

        self=self*fac
        end Subroutine SelfStopReti
